//
//  CHBookmarkBrowserView.h
//  CHAppKit
//
//  Created by Rod Schmidt on 7/7/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHWebKitBrowserView.h"

@class	CHProgressTextField, CHClickableImageView;

@interface CHBookmarkBrowserView : CHWebKitBrowserView 
{
	IBOutlet NSButton*				_backButton;
	IBOutlet NSButton*				_forwardButton;
	IBOutlet NSButton*				_stopReloadButton;
	IBOutlet CHClickableImageView*	_siteImage;
	IBOutlet NSImageView*			_lockImage;
	IBOutlet NSPopUpButton*			_actionButton;
	IBOutlet NSSearchField*			_searchField;
	
	BOOL	_settingURL;

    int _resourceCount;
    int _resourceFailedCount;
    int _resourceCompletedCount;
}

-(IBAction) createWebArchive: (id) sender;
-(IBAction) stopReload: (id) sender;
-(IBAction) makeTextLarger: (id) sender;
-(IBAction) makeTextSmaller: (id) sender;
-(IBAction) search: (id) sender;
-(IBAction) openURL:(id) sender;

-(void) stopLoading;

-(void) setURL: (NSURL*) url;

@end

@interface CHBookmarkBrowserView (Delegate)
-(void) bookmarkBrowserDocumentChanged:(CHBookmarkBrowserView *) bookmarkBrowser;
-(void) bookmarkBrowserSettingsChanged:(CHBookmarkBrowserView *) bookmarkBrowser;
-(void) createWebArchiveFromContentsOfBrowser:(CHBookmarkBrowserView *) browser;
@end
