//
//  CHCalendarButton.h
//  CHAppKit
//
//  Created by Rod Schmidt on 1/29/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface CHCalendarButton : NSButton 
{
	IBOutlet NSView *			_field;	// field button is associated with
	IBOutlet id delegate;
	
	NSPanel *_calendarPanel;
	NSDatePicker *_datePicker;
}

-(id)initWithOrigin:(NSPoint)anOrigin;

-(NSDate *)date;
-(void)setDate:(NSDate *)aDate;
- (NSCalendar *)calendar;
- (void)setCalendar:(NSCalendar *)aCalendar;
- (NSDate *)minDate;
- (void)setMinDate:(NSDate *)newMinDate;
- (NSDate *)maxDate;
- (void)setMaxDate:(NSDate *)newMaxDate;

-(id)delegate;
-(void)setDelegate:(id)aDelegate;

-(id)field;
-(void)setField:(NSView *)aView;

@end

@interface NSObject (CHCalendarButtonDelegate)

-(void)calendarButtonDateChanged:(CHCalendarButton *)button;

@end
