//
//  CHClipArtMatrix.h
//  AddressBookStudio
//
//  Created by Robert McCullough on Thu Sep 05 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHFoundation/CHFoundation.h>

@class CHClipArtController;

@interface CHClipArtMatrix : NSMatrix
{
	NSArray *_clipArtArrays;
	NSArray *_folderPathArray;
	NSArray *_photoKeyArray;
	NSArray *_selectedIndexArray;
	CHClipArtController *_clipArtController;
	int _controllerType;
	BOOL _sizeImageToTarget;
	
    @private
    NSEvent *downEvent;
}

- (void)setClipArtController:(CHClipArtController *)controller controllerType:(int)controllerType;
- (void)setClipArtArrays:(NSArray *)clipArtArrays folderPathArray:(NSArray *)folderPathArray;
- (void)setPhotoKeyArray:(NSArray *)_photoKeyArray;
- (void)setSelectedIndexArray:(NSArray *)selectedIndexArray;
- (NSDictionary *)clipArtDictionaryAtIndex:(NSInteger)index folderIndex:(NSInteger *)folderIndex;
- (int)controllerType;
- (void)setSizeImageToTarget:(BOOL)sizeImageToTarget;

// Dragging Source methods
- (void)startDrag:(NSEvent *)event;
- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)event;
- (BOOL)acceptsFirstMouse:(NSEvent *)event;
- (void)mouseDown:(NSEvent *)event;
- (void)mouseDragged:(NSEvent *)event;
- (NSEvent *)downEvent;
- (void)setDownEvent:(NSEvent *)event;

@end
