//
//  CHClipArtUpdate.h
//  CHSoftwareUpdate
//
//  Created by Nick Zitzmann on Mon Mar 29 2004.
//  Copyright (c) 2004 Chronos LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHNibLoadingObject.h"


@interface CHClipArtUpdate : CHNibLoadingObject
{
	// Class objects!
	NSMutableArray *_downloads;				// array of NSDictionary objects containing the new clip art name, URL, and whether or not it should be downloaded
	NSMutableArray *_urlRequests;			// array of NSURLRequest objects
	NSURLDownload *_currentDownload;		// current file being downloaded
	NSString *_currentDownloadLocalPath;
	NSMutableArray *_filesToBeUnpacked;
	long long _currentDownloadSize;
	long long _currentDownloadTotalSize;
	
	// Outlets!
	IBOutlet NSPanel *wndClipArtUpdate;
	IBOutlet NSProgressIndicator *priDownloadProgress;
	IBOutlet NSButton *cmdOK;
	IBOutlet NSButton *cmdCancel;
	IBOutlet NSTableView *tblClipArt;
	IBOutlet NSTextField *txtStatus;
}
// Class methods
+ (CHClipArtUpdate *)sharedInstance;

// Instance methods
- (void)beginCheckForUpdates;

// IB actions
- (IBAction)okClicked:(id)sender;
- (IBAction)cancelClicked:(id)sender;

@end
