//
//  CHConfirmSheet.h
//  CHAppKit
//
//  Created by Rod Schmidt on 9/19/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface CHConfirmSheet : NSObject 
{
	IBOutlet NSButton*		_cancelButton;
    IBOutlet NSButton*		_okButton;
	IBOutlet NSButton*		_okDontAskButton;
    IBOutlet NSWindow*		_sheetWindow;
    IBOutlet NSTextField*	_titleText;
    IBOutlet NSTextField*	_messageText;
	IBOutlet NSImageView*	_appIconView;

	id				_target;
    NSInvocation*	_invocation;
    NSString*		_silencingDefaultsKey;
    NSWindow*		_parentWindow;
}

-(IBAction) sheetOK: (id) sender;
-(IBAction) sheetOKDontAsk: (id) sender;
-(IBAction) sheetCancel: (id) sender;

- (id) target;
- (void) setTarget: (id) aTarget;
- (NSInvocation *) invocation;
- (void) setInvocation: (NSInvocation *) anInvocation;
- (NSString *) silencingDefaultsKey;
- (void) setSilencingDefaultsKey: (NSString *) aSilencingDefaultsKey;
- (NSWindow *) parentWindow;
- (void) setParentWindow: (NSWindow *) aParentWindow;

@end

@interface NSObject (CHConfirmSheet)

-(id) confirmWithWindow: (NSWindow*) aWindow
		   silencingKey: (NSString*) aSilencingKey
			  canCancel: (BOOL) aCanCancel
			   OKButton: (NSString*) anOKTitle
				  title: (NSString*) aTitle
				 format: (NSString*) format, ...;

@end
