//
//  CHDateControl.h
//
//  Created by Rod Schmidt on 7/28/2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <CHFoundation/CHFoundation.h>
#import "CHDateEnums.h"

#define CHDATECONTROL_MAX_CELL_COUNT			3
#define CHDATECONTROL_MAX_SEPERATOR_CELL_COUNT	2

@interface CHDateControl : NSControl
{
    IBOutlet id			delegate;
    IBOutlet NSStepper* stepper;
	
    NSCalendarDate* _currentDate;
    NSCell*			_cells[CHDATECONTROL_MAX_CELL_COUNT];
    NSRect			_rects[CHDATECONTROL_MAX_CELL_COUNT];
    NSCell*			_separatorCells[CHDATECONTROL_MAX_SEPERATOR_CELL_COUNT];
    NSRect			_separatorRects[CHDATECONTROL_MAX_SEPERATOR_CELL_COUNT];
	NSInteger		_selected;
    BOOL			_isUsingFieldEditor;
    double			_stepperMidValue;
	unichar			_separatorCharacter;
	NSInteger		_cellMax[CHDATECONTROL_MAX_CELL_COUNT];
	NSInteger		_monthCellNdx;
	NSInteger		_dayCellNdx;
	NSInteger		_yearCellNdx;
	BOOL			_showCentury;
	BOOL			_leadingZeroForMonth;
	BOOL			_leadingZeroForDay;
	BOOL			_selectOnBecomeFirstResponder;
	NSControlSize	_controlSize;
	BOOL			_dateControlBordered;
	id				_calendar;	// actually an NSCalendar object; used on Tiger & later
	BOOL			_drawCarat;
}

-(IBAction) setDateValue: (id) sender;

-(id) date;
-(void) setDate: (id) aDate;

-(void) setDelegate: (id) aDelegate;

- (void)editCell:(NSInteger)aSelected;
-(void) editOff;

- (NSInteger)selected;
- (void)setSelected:(NSInteger)aSelected;

- (void)setMonth:(NSInteger)aMonth;
- (NSInteger)month;

- (void)setDay:(NSInteger) aDay;
- (NSInteger)day;

- (void)setYear:(NSInteger)aYear;
- (NSInteger)year;

-(BOOL) acceptNewValueInSelectedCell: (id) sender;

-(NSStepper*) stepper;
-(void) setStepper: (NSStepper*) aStepper;

- (NSControlSize)controlSize;
- (void)setControlSize:(NSControlSize)controlSize;

- (BOOL)isBordered;
- (void)setBordered:(BOOL)bordered;

- (BOOL)drawsBackground;
- (void)setDrawsBackground:(BOOL)flag;

#if MAC_OS_X_VERSION_10_4 <= MAC_OS_X_VERSION_MAX_ALLOWED
- (NSCalendar *)calendar;
- (void)setCalendar:(NSCalendar *)calendar;
- (NSInteger)era;
- (void)setEra:(NSInteger)anEra;
#endif

- (BOOL)drawsCaratIfStepperIsPresent;
- (void)setDrawsCaratIfStepperIsPresent:(BOOL)shouldDraw;

@end
