//
//  CHDateView.h
//  CHAppKit
//
//  Created by Rod Schmidt on Thu Jul 29 2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <CHFoundation/CHFoundation.h>
#import "CHDateEnums.h"

@class CHDateControl, CHCalendar;

@interface CHDateView : NSView 
{
	IBOutlet id		delegate;
	
	CHDateControl*  _dateField;
	NSStepper*		_stepper;
	CHCalendar*		_calendar;
	
	BOOL	_showCalendar;
	BOOL	_hasStepper;
}

-(id) date;
-(void) setDate: (id) aDate;

-(void) setDelegate: (id) aDelegate;

- (void)setMonth:(NSInteger)aMonth;
- (NSInteger)month;

- (void)setDay:(NSInteger)aDay;
- (NSInteger)day;

- (void)setYear:(NSInteger)aYear;
- (NSInteger)year;

-(BOOL) showCalendar;
-(void) setShowCalendar: (BOOL) show;

-(BOOL) hasStepper;
-(void) setHasStepper: (BOOL) hasStepper;

-(BOOL) isEnabled;
-(void) setEnabled: (BOOL) enabled;

- (NSControlSize)controlSize;
- (void)setControlSize:(NSControlSize)controlSize;

- (BOOL)isBordered;
- (void)setBordered:(BOOL)bordered;

- (BOOL)drawsBackground;
- (void)setDrawsBackground:(BOOL)flag;

- (CHDateControl *)control;

#if MAC_OS_X_VERSION_10_4 <= MAC_OS_X_VERSION_MAX_ALLOWED
- (NSCalendar *)calendar;
- (void)setCalendar:(NSCalendar *)calendar;
- (NSInteger)era;
- (void)setEra:(NSInteger)anEra;
#endif

- (BOOL)drawsCaratIfStepperIsPresent;
- (void)setDrawsCaratIfStepperIsPresent:(BOOL)shouldDraw;

@end

@interface NSObject (CHDateViewDelegate)
- (void)dateViewStartedToChange:(CHDateView *)aDateView;
-(void) dateViewDidChange: (CHDateView*) aDateView;
@end

