//
//  CHFileBrowserView.h
//  CHAppKit
//
//  Created by Rod Schmidt on 9/22/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHControlBar.h"
#import "CHBrowserView.h"
#import "CHBrowserPageView.h"

#define CHFileBrowserFileChangedNotification @"CHFileBrowserFileChangedNotification"

@class CHFileBrowserPageView;

@interface CHFileBrowserView : CHBrowserView 
{
	IBOutlet CHBrowserPageView*	_pageView;
	IBOutlet NSButton*			_addButton;
	IBOutlet NSPopUpButton*		_actionButton;
	
	NSString*		_filename;
	NSFileWrapper*	_fileWrapper;
	BOOL			_dontTellDelegate;
	BOOL			_linked;
}

-(IBAction) openWith: (id) sender;
-(IBAction) launch: (id) sender;
-(IBAction) revealInFinder: (id) sender;
-(IBAction) saveCopyAs: (id) sender;

-(NSString*) filename;
-(void) setFilename: (NSString*) filename data: (NSData*) data;

-(NSData*) data;

-(BOOL) canOpen;
-(BOOL) canSetDocument;
-(void) setCanSetDocument: (BOOL) flag;

-(BOOL) saveCopyTo: (NSString*) path;

-(BOOL) isLinked;
-(void) setLinked: (BOOL) linked;

-(void) importFromFile: (NSString*) filename;
-(void) importFromFileAfterConfirm: (NSString*) filename;
-(void) confirmReplace: (NSString*) newFilename;

// Protected methods. Should only be called by subclasses
-(NSArray*) allowedFileTypes;
-(void) fireFileChanged;
-(NSString*) noun;
-(void) promptForFile: (id) sender;
-(void) setFileData: (NSData*) data;
-(NSString*) temporaryFilename;
-(void) updateOpenWithMenu;
-(void) updateURLField: (BOOL) linked;

@end

@interface CHFileBrowserView (Delegate)
-(void) browserFileChanged: (CHFileBrowserView*) browser;
@end
