//
//  CHLicenseManager.h
//  CHAppKit
//
//  Created by Jerry Halls on 11/21/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class CHCountdownController;
@class CHExpiredController;
@class CHLicenseWindowController;
@class CHLicense;

extern NSString	*CHLicenseExpiredNotification;
extern NSString	*CHLicenseQuitSoftwareNotification;
extern NSString *CHLicensedSuccessfullyNotification;

@interface CHLicenseManager : NSObject {
	BOOL						_quitInsteadOfCancel;
	NSTimer*					_licenseTimer;
	CHCountdownController*		_countdownController;
	CHExpiredController*		_expiredController;
	CHLicenseWindowController*	_licenseWindowController;
	BOOL						_isInModalEventLoop;
	
	NSString*					_currentProductNameString;
	NSString*					_currentProductLicenseVersionString;
	NSString*					_currentProductActualVersionString;
	NSString*					_currentProductRegisterURLString;
	NSString*					_currentProductLatestVersionString;
	NSArray*					_currentProductPromoImagesArray;
	BOOL						_isCurrentProductLicensed;
	BOOL						_isCurrentProductExpired;
}

- (id)init:(BOOL)aQuitInsteadOfCancel;
- (void)setCurrentProduct:(int)aFlag withProductName:(NSString*)aCurrentProductNameString withLicenseVersion:(NSString*)aLicenseVersionString withRegisterURL:(NSString*)aRegisterURL withPromoImages:(NSArray*)aPromoImageArray;
- (NSString*)currentProductRegisterURL;
- (NSString*)currentProductName;
- (NSString*)currentProductLicenseVersion;
- (CHLicense*)license;
- (BOOL)isCurrentProductLicensed;
- (BOOL)isCurrentProductExpired;

- (void)startLicenseTimer;

- (BOOL)successfullyLicensedAction:(id)sender;
- (void)showLicenseDialog:(BOOL)aUseQuitButton;

- (int)numLicensesForProduct:(NSString*)aProductNameString withLicenseVersion:(NSString*)aLicenseVersionString;
- (NSArray*)licensedProducts;
- (int)numUsersForLikeLicenses:(NSArray*)aLicensesArray;

- (BOOL)letUserLicenseSoftwareForNewerCurrentProductVersion;
- (BOOL)letUserLicenseSoftwareForInsufficientLicensesForCurrentProduct:(int)aCurrentNumberOfUsersWithPrivileges;

@end
