//
//  CHProgressWindow.h
//  CHAppKit
//
//  Created by Rod Schmidt on Fri Jul 09 2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>

@interface CHProgressWindow : NSWindowController 
{
	IBOutlet NSTextField*			_message;
	IBOutlet NSProgressIndicator*   _progressBar;
	IBOutlet NSImageView*			_appIconView;
	IBOutlet NSButton*				_cancelButton;
	IBOutlet NSTextField *			_secondaryMessage;
	
	id	_cancelTarget;
	SEL	_cancelAction;
}

-(IBAction) cancelAction: (id) sender;

+(CHProgressWindow*) startProgressWindowWithTitle: (NSString*) title max: (double) max docWindow: (NSWindow*) docWindow;

-(id) initWithTitle: (NSString*) title max: (double) max;
-(void) setMessage: (NSString*) aMessage;
-(void) setSecondaryMessage:(NSString *) message;
-(void) setValue: (double) aValue;
-(double) maxValue;
-(void) setIndeterminate: (BOOL) indeterminate;
-(void) setCancelTarget: (id) target action: (SEL) action;

-(void) endProgressWindow;

@end
