//
//  CHRegistrationManager.h
//  CHRegistration
//
//  Created by Jerry Halls on Mon Mar 22 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class CHCountdownController;
@class CHExpiredController;
@class CHLicenseController;
@class CHRegistration;

extern NSString	*CHRegistrationExpiredNotification;
extern NSString	*CHRegistrationQuitSoftwareNotification;

@interface CHRegistrationManager : NSObject {
	NSTimer					*_registrationTimer;
	BOOL					_isRegistered;
	BOOL					_isExpired;
	
	CHCountdownController	*_countdownController;
	CHExpiredController		*_expiredController;
	CHLicenseController		*_licenseController;
	BOOL					_isInModalEventLoop;
	
	NSString*				_productNameString;
	NSString*				_registrationFolderString;
	NSString*				_firstLetterString;
	NSString*				_registerURLString;
	NSArray*				_promoImagesArray;
	NSString*				_latestVersionString;

	BOOL					_quitInsteadOfCancel;
}

- (id)init:(NSString*)aProductNameString withRegistrationFolder:(NSString*)aRegistrationFolderString withFirstLetter:(NSString*)aFirstLetterString quitInsteadOfCancel:(BOOL)aQuitInsteadOfCancel;
- (void)setKeys:(int)aFlag regKeyIndex:(long)aRegKeyIndex CDKeyIndex:(long)aCDKeyIndex regKeyFront:(long)aRegKeyFront regKeyBack:(long)aRegKeyBack CDVerifier:(long)aCDVerifier;
- (void)setRegisterURL:(NSString*)aRegisterURL;
- (NSString*)registerURL;
- (void)setPromoImages:(NSArray*)aImageArray;
- (CHRegistration*)registration;
- (BOOL)isRegistered;
- (BOOL)isExpired;
- (BOOL)figureLatestVersion;
- (void)checkForUpdate;

- (void)stopRegistrationTimer;
- (void)startRegistrationTimer;

- (void)successfullyRegisteredAction:(id)sender;
- (void)showExpiredDialog;
- (void)showLicenseDialog:(BOOL)aUseQuitButton;


@end
