//
//  CHTimeControl.h
//
//  Created by Rod Schmidt on 7/23/2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <CHFoundation/CHFoundation.h>
#import "CHTimeEnums.h"

#define CHTIMECONTROL_MAX_CELL_COUNT			4
#define CHTIMECONTROL_MAX_SEPERATOR_CELL_COUNT	2

#define CHTIMECONTROL_HOUR_ID			0
#define CHTIMECONTROL_MINUTE_ID			1
#define CHTIMECONTROL_SECOND_ID			2
#define CHTIMECONTROL_AMPM_ID			3

@interface CHTimeControl : NSControl
{
    IBOutlet id			delegate;
    IBOutlet NSStepper* stepper;
	
    NSCalendarDate* _currentDate;
    NSCell*			_cells[CHTIMECONTROL_MAX_CELL_COUNT];
    NSRect			_rects[CHTIMECONTROL_MAX_CELL_COUNT];
    NSCell*			_separatorCells[CHTIMECONTROL_MAX_SEPERATOR_CELL_COUNT];
    NSRect			_separatorRects[CHTIMECONTROL_MAX_SEPERATOR_CELL_COUNT];
    int				_selected;
    BOOL			_isUsingFieldEditor;
    double			_stepperMidValue;
	BOOL			_militaryFormat;
	BOOL			_displaySeconds;
	BOOL			_leadingZeroForHour;
	BOOL			_zeroForNoonAndMidnight;	// Only applies to non military time
	unichar			_separatorCharacter;
	unsigned		_numberOfCells;
	unsigned		_numberOfSeparatorCells;
	int				_cellMax[CHTIMECONTROL_MAX_CELL_COUNT];
	BOOL			_selectOnBecomeFirstResponder;
	NSControlSize	_controlSize;
	BOOL			_force24HourMode;
	BOOL			_timeControlBordered;
	BOOL			_drawCarat;
}

-(IBAction) setTimeValue: (id) sender;

-(id) date;
-(void) setDate: (id) aDate;

-(void) setDelegate: (id) aDelegate;

-(void) editCell: (int) aSelected;
-(void) editOff;

-(int) selected;
-(void) setSelected: (int) aSelected;

- (void)setHour:(NSInteger)aHour;
- (NSInteger)hour;

- (void)setMinute:(NSInteger)minute;
- (NSInteger)minute;

- (void)setSecond:(NSInteger)aSecond;
- (NSInteger)second;

-(void) setAMPM: (CHTimeControl_AMPM) ampm;
-(CHTimeControl_AMPM) AMPM;

-(BOOL) acceptNewValueInSelectedCell: (id) sender;

-(BOOL) displaySeconds;
-(void) setDisplaySeconds: (BOOL) display;

-(NSStepper*) stepper;
-(void) setStepper: (NSStepper*) aStepper;

- (NSControlSize)controlSize;
- (void)setControlSize:(NSControlSize)controlSize;

- (BOOL)always24HourTime;
- (void)setAlways24HourTime:(BOOL)always24Hours;

- (BOOL)isBordered;
- (void)setBordered:(BOOL)bordered;

- (BOOL)drawsBackground;
- (void)setDrawsBackground:(BOOL)flag;

- (BOOL)drawsCaratIfStepperIsPresent;
- (void)setDrawsCaratIfStepperIsPresent:(BOOL)shouldDraw;

@end