//
//  CHTimeView.h
//  CHAppKit
//
//  Created by Rod Schmidt on Tue Jul 27 2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <CHFoundation/CHFoundation.h>
#import "CHTimeEnums.h"

@class CHTimeControl;

@interface CHTimeView : NSView 
{
	IBOutlet id delegate;
	
	CHTimeControl*  _timeField;
	NSStepper*		_stepper;
	BOOL			_hasStepper;
}

-(id) date;
-(void) setDate: (id) aDate;

-(id) delegate;
-(void) setDelegate: (id) aDelegate;

- (void)setHour:(NSInteger)aHour;
- (NSInteger)hour;

- (void)setMinute:(NSInteger)aMinute;
- (NSInteger)minute;

- (void)setSecond:(NSInteger)aSecond;
- (NSInteger)second;

-(void) setAMPM: (CHTimeControl_AMPM) ampm;
-(CHTimeControl_AMPM) AMPM;

-(BOOL) displaySeconds;
-(void) setDisplaySeconds: (BOOL) display;

-(BOOL) hasStepper;
-(void) setHasStepper: (BOOL) hasStepper;

-(BOOL) isEnabled;
-(void) setEnabled: (BOOL) enabled;

- (NSControlSize)controlSize;
- (void)setControlSize:(NSControlSize)controlSize;

- (BOOL)always24HourTime;
- (void)setAlways24HourTime:(BOOL)always24Hours;

- (BOOL)isBordered;
- (void)setBordered:(BOOL)bordered;

- (BOOL)drawsBackground;
- (void)setDrawsBackground:(BOOL)flag;

- (BOOL)drawsCaratIfStepperIsPresent;
- (void)setDrawsCaratIfStepperIsPresent:(BOOL)shouldDraw;

- (CHTimeControl *)control;

@end

@interface NSObject (CHTimeViewDelegate)
- (void)timeViewStartedToChange:(CHTimeView *)aTimeView;
- (void)timeViewDidChange:(CHTimeView *)aTimeView;
@end
