//
//  CHWebArchiveBrowserView.h
//  CHAppKit
//
//  Created by Rod Schmidt on 7/7/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHWebKitBrowserView.h"

@class CHProgressTextField;

@interface CHWebArchiveBrowserView : CHWebKitBrowserView 
{
	IBOutlet NSButton*				_addButton;
	IBOutlet NSPopUpButton*			_actionButton;
	IBOutlet NSTextField*			_urlStaticField;
	IBOutlet CHProgressTextField*	_urlInputField;
	IBOutlet NSButton*				_stopButton;
	
	BOOL	_dragAllowed;
	BOOL	_linked;
	BOOL	_displayingDragHere;
	BOOL	_displayingMissing;
	BOOL	_handleDrop;
	BOOL	_handleEnteredURL;
	BOOL	_handleChosenFile;
	
	NSData*	_originalWebArchiveData;
    int		_resourceCount;
    int		_resourceFailedCount;
    int		_resourceCompletedCount;
}

-(IBAction) openWith: (id) sender;
-(IBAction) revealInFinder: (id) sender;
-(IBAction) saveCopyAs: (id) sender;
-(IBAction) setDocument: (id) sender;
-(IBAction) stopReload: (id) sender;

-(NSData*) webArchiveData;
-(void) setURL: (NSURL*) url data: (NSData*) data;

-(void) stopLoading;

@end

@interface CHWebArchiveBrowserView (Delegate)
-(void) webArchiveBrowserDocumentChanged: (CHWebArchiveBrowserView*) webArchiveBrowser;
@end
