//
//  NSBezierPath+CHExtensions.h
//  App Launcher
//
//  Created by Jerry Halls on Wed Jul 03 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHFoundation/CHFoundation.h>

@interface NSBezierPath (CHExtensions)

+(void)fillRoundedRect:(NSRect)aRect radius:(CGFloat)aRadius;
+ (void)fillOneSidedRoundedRect:(NSRect)aRect onLeftSide:(BOOL)onLeftSide radius:(CGFloat)aRadius;	// if onLeftSide is YES then the left side is rounded, if NO then the right side is rounded
+(void)strokeRoundedRect:(NSRect)aRect radius:(CGFloat)aRadius lineWidth:(CGFloat)aLineWidth;

+(void) fillBottomRoundedRect:(NSRect)aRect radius:(CGFloat)aRadius;

+(void) fillTabRect:(NSRect)aRect radius:(CGFloat)aRadius;
+(void) strokeTabRect:(NSRect)aRect radius:(CGFloat)aRadius lineWidth:(CGFloat)aLineWidth;

+(void) fillReverseTabRect:(NSRect)aRect radius:(CGFloat)aRadius;
+(void) strokeReverseTabRect:(NSRect)aRect radius:(CGFloat)aRadius lineWidth:(CGFloat)aLineWidth;

-(void)appendRoundedRect:(NSRect)aRect radius:(CGFloat)aRadius;
- (void)appendOneSidedRoundedRect:(NSRect)aRect onLeftSide:(BOOL)onLeftSide radius:(CGFloat)aRadius;
-(void) appendBottomRoundedRect:(NSRect)aRect radius:(CGFloat)aRadius;

-(void) appendTabRect:(NSRect)aRect radius:(CGFloat)aRadius;
-(void) appendOpenTabRect:(NSRect)aRect radius:(CGFloat)aRadius;

-(void) appendReverseTabRect:(NSRect)aRect radius:(CGFloat)aRadius;
-(void) appendReverseOpenTabRect:(NSRect)aRect radius:(CGFloat)aRadius;

@end
