//
//  CHDatabase+Alarms.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on 3/25/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import "CHDatabase.h"

@class SBAlarmInfo;
@class SBNote;

#define SBAlarmAddedNotification	@"SBAlarmAddedNotification"
#define SBAlarmRemovedNotification	@"SBAlarmRemovedNotification"
#define SBAlarmChangedNotification	@"SBAlarmChangedNotification"

@interface CHDatabase (Alarms)

-(BOOL) addAlarmForNote: (SBNote*) note alarmInfo: (SBAlarmInfo*) alarmInfo;	// deprecated, use -addAlarmWithAlarmInfo: instead and set the note ID beforehand
-(BOOL) addAlarmWithAlarmInfo: (SBAlarmInfo*) alarmInfo;
-(BOOL) copyAlarmInfosForNote: (SBNote*) note toNote: (SBNote*) anotherNote;
-(BOOL) updateAlarmForNote: (SBNote*) note alarmInfo: (SBAlarmInfo*) alarmInfo;	// deprecated, use -updateAlarmWithAlarmInfo: instead
-(BOOL) updateAlarmWithAlarmInfo: (SBAlarmInfo*) alarmInfo;
-(BOOL) removeAlarmForNote: (SBNote*) note;
- (BOOL)deleteAlarm:(SBAlarmInfo *)alarmInfo;
-(BOOL) alarmInfoForNote: (SBNote*) note alarmInfo: (SBAlarmInfo*) alarmInfo;
-(NSArray*) alarmsBetween: (NSCalendarDate*) firstDate and: (NSCalendarDate*) secondDate;
-(NSArray*) alarmsBefore: (NSCalendarDate*) date;
-(NSDictionary*) alarmsForNotes:(NSArray*) notes;
- (NSArray *)alarms;
- (SBAlarmInfo *)alarmWithUUID:(NSString *)uuid;

@end
