//
//  CHDatabase+Color.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on 3/24/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import "CHDatabase.h"

@class SBColorInfo;

@interface CHDatabase (Color)

-(BOOL) createColorsTable;
-(BOOL) createDefaultColors;

// Returns ID of new color. -1 for error
-(long long) addColor: (NSColor*) color withName: (NSString*) colorName;
- (BOOL)addColor:(SBColorInfo *)color;
-(BOOL) updateColor: (SBColorInfo*) color;
-(BOOL) deleteColor: (SBColorInfo*) color;

-(NSArray*) colors;
-(SBColorInfo*) colorWithID: (long long) colorID;
- (SBColorInfo *)colorWithUUID:(NSString *)uuid;
-(NSColor*) colorForColorID: (long long) colorID;
-(long long) colorIDForColor: (NSColor*) color;

-(long long) whiteColorID;

// The following three methods are intended for use by SBOpenBaseNotificationHandler only. No other class should need to use them.
- (SBColorInfo *)addColorWithColorIDIntoCache:(long long)colorID;
- (SBColorInfo *)updateColorWithColorIDInCache:(long long)colorID;
- (void)removeColorWithColorIDFromCache:(long long)colorID;

@end
