//
//  CHDatabase+Forms.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 2/1/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHDatabase.h"

@class CHFormDefinition;

@interface CHDatabase (Forms) 

-(BOOL)createFormsTable;

-(NSArray *)forms;
-(CHFormDefinition *)formWithID:(long long)rowID;
- (CHFormDefinition *)formWithUUID:(NSString *)uuid;

-(BOOL)addForm:(CHFormDefinition *)formDef;
-(BOOL)deleteForm:(CHFormDefinition *)formDef;
-(BOOL)updateForm:(CHFormDefinition *)formDef;

-(NSUInteger)numberOfNotesUsingForm:(long long)formID;

-(CHFormDefinition *)passwordForm;
-(CHFormDefinition *)serialNumberForm;

-(CHFormDefinition *) createPasswordForm;

@end

@interface CHDatabase (FormsConversion)

-(BOOL) addEmailAndOrgFieldsToSerialForm;

@end
