//
//  CHDatabase+Icons.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 9/14/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHDatabase.h"

@class SBIcon;

// Icon Types (important: must not be greater than 30 characters)
#define SBDefaultLibraryIconType				@"DefaultLibrary"
#define SBDefaultBookIconType					@"DefaultBook"
#define SBDefaultUnfiledIconType				@"DefaultUnfiled"
#define SBDefaultDailyNotesFolderType			@"DefaultDailyNotesFolder"
#define SBDefaultNotesIconType					@"DefaultNotesIconType"
#define SBDefaultiPodBookType					@"DefaultiPodBook"
#define SBDefaultJournalFolderType				@"DefaultJournalFolder"
#define SBDefaultPasswordBookType				@"DefaultPasswordBook"
#define SBDefaultPalmBookType					@"DefaultPalmBook"
#define SBDefaultReceiptBookType				@"DefaultReceiptBook"
#define SBDefaultSmartFolderIconType			@"DefaultSmartFolderIconType"
#define SBDefaultTrashIconType					@"DefaultTrash"
#define SBBookIconType							@"Book"
#define SBDefaultFlaggedFolderIconType			@"DefaultFlaggedSmartFolderIconT"
#define SBDefaultRecentNotesFolderIconType		@"DefaultRecentNotesSmartFolderI"
#define SBDefaultSerialNumberFolderIconType		@"DefaultSerialNumberSmartFolder"

@interface CHDatabase (Icons)
-(NSArray *)icons;
-(SBIcon *)iconWithID:(long long)iconRowID;
-(SBIcon *)iconWithUUID:(NSString *)uuid;
-(NSArray *)iconsWithType:(NSString *)type;

-(BOOL)addIcon:(SBIcon *)icon;
-(BOOL)updateIcon:(SBIcon *)icon;
-(BOOL)deleteIcon:(SBIcon *)icon;
-(BOOL)deleteIconWithID:(long long)iconID;

-(BOOL)iconInUse:(long long)iconID otherThanByFolder:(long long)folderID;

-(BOOL)cleanupFolderIcons;
-(BOOL)updateUnfiledIcon;

@end
