//
//  CHDatabase+Labels.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 3/16/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHDatabase.h"
#import "SBLabelInfo.h"

@interface CHDatabase (Labels)

-(BOOL) addLabel: (SBLabelInfo*) labelInfo;
-(BOOL) addLabel: (NSString*) label withColor: (NSColor*) color forUser: (NSString*) userID;

-(BOOL) createDefaultLabels;
-(BOOL) createDefaultLabelsForUser: (NSString*) userID;

-(BOOL) deleteLabel: (SBLabelInfo*)label;
-(BOOL) deleteLabelsForUser: (long long) userRowID;

-(BOOL) updateLabelColor: (SBLabelInfo*) labelInfo;
-(BOOL) updateLabelName: (SBLabelInfo*) labelInfo;

-(NSArray*) labels;
-(void) resetLabelCache;
-(NSColor*) colorForLabelWithID: (long long) labelID;
-(SBLabelInfo*) labelWithID: (long long) rowid;
-(SBLabelInfo*) labelWithUUID: (NSString*) uuid;

-(NSArray*) noteIDsWithLabel: (SBLabelInfo*) label;

@end
