//
//  CHDatabase+Links.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on 3/25/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import "CHDatabase.h"
#import <CHFoundation/CHFoundation.h>

@class SBNote, ABPerson, PGPerson, SBNoteLinkInfo;

typedef enum
{
	LinkToNote,
	LinkToABPerson,
	LinkToPGPerson
} LinkType;

@interface CHDatabase (Links)

-(BOOL) linkNotes: (NSArray*) notes toNote: (SBNote*) note;
-(BOOL) linkNotes: (NSArray*) notes toPerson: (id) person;	// person can be either an ABPerson or PGPerson
- (NSArray *)linkNotesAndReturnNoteLinkInfoObjects:(NSArray *)notes toPerson:(PGPerson *)person;
-(NSDictionary *)linksForNoteIDs:(CHLongLongIndexSet *)noteIDs;
-(CHLongLongIndexSet *) noteIDsLinkedToNote:(SBNote *) note;
-(NSArray*) notesLinkedToNote: (SBNote*) note;
-(long long) noteLinksIDForNote: (long long) noteID linkedNote: (long long) linkedNoteID;
-(long long) noteLinksIDForNote: (long long) noteID abPersonID: (NSString*) personID;
- (long long)noteLinksIDForNote:(long long)noteID pgPersonID:(long long)pgPersonID;
-(NSArray*) abPeopleLinkedToNote: (SBNote*) note;
- (NSArray *)pgPeopleLinkedToNote:(SBNote *)note;
-(BOOL) removeLinkToNote: (SBNote*) linkedNote fromNote: (SBNote*) srcNote;
- (BOOL)removeLinksToNotes:(NSArray *)notes fromNote:(SBNote *)srcNote;
-(BOOL) removeLinkToNote: (SBNote*) note fromPerson: (id) person;	// again, person can be either an ABPerson or PGPerson

// These methods are intended for syncing links between notes and people. They're probably not that useful for any other purpose. They return NSArrays of SBNoteLinkInfo objects.
- (NSArray *)linkInfosForNote:(SBNote *)note;
- (NSArray *)linkInfosForPerson:(PGPerson *)person;
- (SBNoteLinkInfo *)linkInfoWithUUID:(NSString *)uuid;

@end
