//
//  CHDatabase+Schema.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on 3/25/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import "CHDatabase.h"

// This category is in charge of the database schema (i.e. creating and converting tables, etc.)
@interface CHDatabase (Schema)

// Table creation
//////////////////

-(BOOL) createAlarmsTable;
-(BOOL) createBookIconsTable;
-(BOOL) createCalendarPrivilegesTable;
-(BOOL) createCommunicationsLogTable;
-(BOOL) createContactPrivilegesTable;
-(BOOL) createFolderRelationshipsTable;
-(BOOL) createFolderTypesTable;
-(BOOL) createFoldersTable;
-(BOOL) createNotesTable;
-(BOOL) createNotesLabelTable;
-(BOOL) createNotesUserTable;
-(BOOL) createNoteBooksTable;
-(BOOL) createNoteLinksTable;
-(BOOL) createPrivilegesTable;
-(BOOL) createSettingsTable;
-(BOOL) createSmartFolderRulesTable;

// Conversion methods
//////////////////////

-(BOOL) addDefaultFloatingAndOpacityToFoldersTable;
-(BOOL) addDynamicTitleColumnToNotesTable;
-(BOOL) addFormIDToNotesTable;
-(BOOL) addFlaggedColumnToNotesUserTable;
-(BOOL) addIconTypeIndexToBookIconsTable;
-(BOOL) addIndexesToFolderRelationshipsTable;
-(BOOL) addIsFlaggedForUserColumnToNotesTable;
-(BOOL) addLabelIDColumnToNotesUserTable;
-(BOOL) addMetaDataColumnToNotesUserTable;
-(BOOL) addNoteIDIndexToNoteBooksTable;
-(BOOL) addNoteTitleIndex;
-(BOOL) addNoteUsersForEachNote;
-(BOOL) bringAllowedAppsForAdminAndStaffGroupsUpToDate;
-(BOOL) convertColors;
-(BOOL) convertToNotesUserTable;
-(BOOL) createChronosAdminAndStaffGroups;
-(BOOL) fixUserIDsInAlarmsTable;
-(BOOL) fixUserIDsInNotesUserTable;
-(BOOL) makeKeyIndexInSettingsTableNonUnique;
-(BOOL) makeNoteIDColumInAlarmsTableNonUnique;
-(BOOL) removeAlarmColumnFromNotesTable;
-(BOOL)removeFolderTypesImageIDColumns;
-(BOOL) removeLibraryFolder;
-(BOOL) removeMarginUnitsColumnFromNotesTable;
-(BOOL)removeUnusedFolderTypes;

-(BOOL) addIncludeColumnToFoldersTable;
-(BOOL) addIncludeColumnToNotesUserTable;

-(BOOL) addMissingIndexesForRelationships;

#ifdef USE_DENORMALIZED_SCHEMA
-(BOOL) addDenormalizedNotesColumns;
-(BOOL) initializeDenormalizedNotesColumns;
#endif

- (BOOL)addUUIDColumnToAlarmsAndAssignUUIDsToAlarms;
- (BOOL)addUUIDColumnToColorsAndAssignUUIDsToColors;
- (BOOL)addUUIDColumnToIconsAndAssignUUIDsToIcons;
- (BOOL)addUUIDColumnToNoteLinksAndAssignUUIDsToNoteLinks;
- (BOOL)addCreatedByAndModifiedByColumnsToNotesTable;
- (BOOL)addPhoneNumberColumnToNotesEntity;
- (BOOL)addUUIDColumnToNotesUserAndAssignUUIDsToNotesUser;
- (BOOL)fixMysteriousNotesUserUUIDProblem;
- (BOOL)addKeywordsColumnToNotesTable;
- (BOOL)addUUIDColumnToKeywordsRepositoryAndAssignUUIDsToKeywordsRepository;
- (BOOL)setOEMKey;
- (BOOL)setSearchableContentsToNULLForPrivateNotes;
- (BOOL)makePrivateNotesNotPrivate;
//- (BOOL)encryptPrivateNotes;
- (BOOL)addDefaultFormIDToFoldersTable;

-(DBRecord*) notesUserRecordForNoteWithID: (long long) noteID andUser: (long long) userID;

@end
