//
//  CHDatabase+Service.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/5/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHDatabase.h"
#import "SBNote.h"

@interface CHDatabase (Service)

// General
///////////

-(BOOL)arePrivatesVisible;
-(NSArray *)buildMenuDataForService: (BOOL)aIncludePrivateNotes;
-(long long)getChronosAdminUserID;

// Folders
///////////

-(NSArray *)foldersForService;
-(NSString *)getFolderName: (long long)folderID folderArray: (NSArray *)folderArray;
-(long long)getPasswordsFolderID;
-(long long)getReceiptsFolderID;
-(NSArray *)searchResults: (NSString *)aSearchString showPrivates: (BOOL)aShowPrivates 
			   forFolders: (NSArray *)aFoldersArray;

// Notes
/////////

-(BOOL)doesNoteAlreadyExist: (long long)noteID inArray: (NSArray *)array inFolder: (long long)folderID 
				folderArray: (NSArray *)folderArray;
-(NSData *) getContentsForNoteID:(long long) aNoteID hasWindowType:(SBWindowType *)aWindowType hasURL:(NSURL **) aURL
					   hasFormID:(long long *) aFormID success: (BOOL *)aSuccess;
-(NSMutableArray *)notesWithActions: (BOOL)grabActions includePrivateNotes: (BOOL)includePrivateNotes 
						folderArray: (NSArray *)folderArray;

-(NSDictionary *)noteWithURLInPasswordsFolder: (NSString *)aURLString;

@end
