//
//  CHDatabase+Settings.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on 3/25/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import "CHDatabase.h"

@interface CHDatabase (Settings)

-(BOOL) createDefaultSettings;
-(BOOL) createDefaultSettingsForUser: (long long) userRowID;
-(NSString*) databaseVersion;
-(BOOL) deleteSettingsForUser: (long long) userRowID;
-(BOOL) deleteSetting:(NSString *)key forUser:(long long)userRowID;
-(BOOL) matchesPrivateNotesPassword: (NSString*) aPassword;
-(void) setDatabaseVersion: (NSString*) version;
-(NSDictionary*) loadSettings;
-(BOOL) updateSettingForKey: (NSString*) key withValue: (NSString*) value;
-(BOOL) updateSettings: (NSDictionary*) settings;
-(BOOL) updateUserIDInDefaultSettings;
- (NSString *)keyForSettingRowID:(long long)rowID userID:(long long *)userID;
- (long long)settingRowIDForKey:(NSString *)key;

@end
