//
//  CHDatabase+Sync.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 8/24/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHDatabase.h"

// Keys for the dictionaries inside the arrays returned by the -records... methods below:
extern NSString * const DBSyncExternalTableName;
extern NSString * const DBSyncExternalRowID;
extern NSString * const DBSyncUniqueID;

@interface CHDatabase (Sync)
- (BOOL)createSyncTable;
- (BOOL)createSyncTableAllTriggersForEntitiesWithTableNames:(NSArray *)names multiUser:(BOOL)multiUser;

- (NSSet *)addChangesSinceLastSyncForUser;
- (NSSet *)modifyChangesSinceLastSyncForUser;
- (NSSet *)deleteChangesSinceLastSyncForUser;

- (BOOL)removeAllAddChangesForUserWithUniqueID:(NSString *)uniqueID;
- (BOOL)removeAllAddChangesForUserWithUniqueIDs:(NSArray *)uniqueIDs;
- (BOOL)removeAllModifyChangesForUserWithUniqueID:(NSString *)uniqueID;
- (BOOL)removeAllModifyChangesForUserWithUniqueIDs:(NSArray *)uniqueIDs;
- (BOOL)removeAllDeleteChangesForUserWithUniqueID:(NSString *)uniqueID;
- (BOOL)removeAllDeleteChangesForUserWithUniqueIDs:(NSArray *)uniqueIDs;
- (BOOL)removeChangesForUniqueIDs:(NSArray *)uniqueIDs;
@end
