//
//  CHDatabaseController.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 04/01/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString * const CHDatabaseControllerDidAddRemoteDatabaseNotification;
extern NSString * const CHDatabaseControllerDidRemoveRemoteDatabaseNotification;

@class CHDatabase;

@interface CHDatabaseController : NSObject
{
	CHDatabase *_localDatabase;
	NSMutableArray *_remoteDatabases;
	NSRecursiveLock *_remoteDatabasesLock;
}

+ (CHDatabaseController *)sharedController;

- (CHDatabase *)localDatabase;
- (void)addRemoteDatabase:(CHDatabase *)remoteDatabase;
- (void)addRemoteDatabase:(CHDatabase *)remoteDatabase sendNotification:(BOOL)sendNotification;
- (void)removeRemoteDatabase:(CHDatabase *)remoteDatabase;
- (void)removeRemoteDatabase:(CHDatabase *)remoteDatabase sendNotification:(BOOL)sendNotification;

- (CHDatabase *)databaseWithServerID:(NSString *)serverID;
- (NSArray *)databasesWithServerID:(NSString *)serverID;
-(CHDatabase*) databaseWithServerID: (NSString*) serverID andUserID: (NSString*) userID;
- (NSArray *)databasesWithPersistentID:(NSString *)persistentID;
-(CHDatabase*) databaseWithPersistentID: (NSString*) persistentID andUserID: (NSString*) userID;
- (NSArray *)allDatabases;
- (NSArray *)connectedRemoteDatabases;
- (NSArray *)databasesThatMayBeAdministered;
- (NSArray *)remoteDatabasesThatMayBeAdministered;
- (unsigned int)numberOfDatabasesWithSameNameAsDatabase:(CHDatabase *)db;
- (BOOL)isLocalDatabaseID:(NSString*)aDatabaseIDString;

@end
