//
// Prefix header for all source files of the 'CHDatabaseKit' target in the 'CHDatabaseKit' project.
//

#ifdef __OBJC__

#import <Cocoa/Cocoa.h>
#import <CHDatabaseKit/CHTypes.h>
#import <CHDatabaseKit/CHDatabaseController.h>
#import <CHDatabaseKit/CHDatabase.h>
#import <CHDatabaseKit/CHDatabase+Alarms.h>
#import <CHDatabaseKit/CHDatabase+Color.h>
#import <CHDatabaseKit/CHDatabase+Folders.h>
#import <CHDatabaseKit/CHDatabase+Labels.h>
#import <CHDatabaseKit/CHDatabase+Links.h>
#import <CHDatabaseKit/CHDatabase+Notes.h>
#import <CHDatabaseKit/CHDatabase+NoteCommunication.h>
#import <CHDatabaseKit/CHDatabase+Privileges.h>
#import <CHDatabaseKit/CHDatabase+Schema.h>
#import <CHDatabaseKit/CHDatabase+Service.h>
#import <CHDatabaseKit/CHDatabase+Settings.h>
#import <CHDatabaseKit/CHDatabase+Icons.h>
#import <CHDatabaseKit/CHDatabase+Sync.h>
#import <CHDatabaseKit/CHDatabase+Palm.h>
#import <CHDatabaseKit/CHDatabase+License.h>
#import <CHDatabaseKit/CHOBBackup.h>
#import <CHDatabaseKit/CHOBBackupScheduler.h>
#import <CHDatabaseKit/OpenBaseNotificationHandler.h>
#import <CHDatabaseKit/SBAlarmInfo.h>
#import <CHDatabaseKit/SBColorInfo.h>
#import <CHDatabaseKit/SBNoteLinkInfo.h>
#import <CHDatabaseKit/SBFolder.h>
#import <CHDatabaseKit/SBSmartFolder.h>
#import <CHDatabaseKit/SBSmartFolderRule.h>
#import <CHDatabaseKit/SBIcon.h>
#import <CHDatabaseKit/SBNote.h>
#import <CHDatabaseKit/SBNotesCache.h>
#import <CHDatabaseKit/SBUser.h>
#import <CHDatabaseKit/SBLabelInfo.h>
#import <CHDatabaseKit/DBEntity+CHExtensions.h>
#import <CHDatabaseKit/DBRecord+CHExtensions.h>
#import <CHDatabaseKit/OpenBase+CHExtensions.h>
#import <CHDatabaseKit/OpenBaseAdminConnection+CHExtensions.h>
#import <CHDatabaseKit/CHKeychainFunctions.h>
#import <CHDatabaseKit/StickyBrainProtocol.h>
#import <CHDatabaseKit/SBFolderHierarchy.h>

#import <CHDatabaseKit/CHDatabase+ContactsAndGroups.h>
#import <CHDatabaseKit/PGContactsModelController.h>
#import <CHDatabaseKit/PGContactsModel.h>
#import <CHDatabaseKit/PGRecord.h>
#import <CHDatabaseKit/PGPerson.h>
#import <CHDatabaseKit/PGGroup.h>
#import <CHDatabaseKit/PGAllGroup.h>
#import <CHDatabaseKit/PGMultiValue.h>
#import <CHDatabaseKit/PGFieldStrings.h>
#import <CHDatabaseKit/PGSearchSession.h>
#import <CHDatabaseKit/PGRecord+Compare.h>
#import <CHDatabaseKit/PGRecord+Merge.h>
#import <CHDatabaseKit/PGMultiValue+Sorting.h>

#import <CHDatabaseKit/CHDatabase+Forms.h>
#import <CHDatabaseKit/CHFormDefinition.h>
#import <CHDatabaseKit/CHFormFieldDefinition.h>

#import <CHDatabaseKit/CHDatabase+Calendars.h>
#import <CHDatabaseKit/PGCalendarsModelController.h>
#import <CHDatabaseKit/PGCalendarsModel.h>
#import <CHDatabaseKit/PGCalendarEnums.h>
#import <CHDatabaseKit/PGCalendarFieldStrings.h>
#import <CHDatabaseKit/PGCalendarRecord.h>
#import <CHDatabaseKit/PGCalendar.h>
#import <CHDatabaseKit/PGCalendarOccurrableRecord.h>
#import <CHDatabaseKit/PGCalendarEvent.h>
#import <CHDatabaseKit/PGCalendarTask.h>
#import <CHDatabaseKit/PGCalendarEventTaskAttribute.h>
#import <CHDatabaseKit/PGCalendarAlarm.h>
#import <CHDatabaseKit/PGCalendarAudioAlarm.h>
#import <CHDatabaseKit/PGCalendarDisplayAlarm.h>
#import <CHDatabaseKit/PGCalendarMailAlarm.h>
#import <CHDatabaseKit/PGCalendarExecuteAlarm.h>
#import <CHDatabaseKit/PGCalendarAttendee.h>
#import <CHDatabaseKit/PGRecurrence.h>
#import <CHDatabaseKit/PGCalendarOrganizer.h>
#import <CHDatabaseKit/PGCalendar+VCalTranslation.h>
#import <CHDatabaseKit/PGCalendarSearchSession.h>
#import <CHDatabaseKit/PGCalendarRecord+Duplicate.h>

#import <CHDatabaseKit/PGAddressBookManager.h>
#import <CHDatabaseKit/PGAddressBook.h>
#import <CHDatabaseKit/PGAddressBookLocal.h>
#import <CHDatabaseKit/PGRecordABExtensions.h>
#import <CHDatabaseKit/PGSpotlightMetadataUpdater.h>

#import <CHDatabaseKit/SBLibrary.h>
#import <CHDatabaseKit/SBLibrary+Alarms.h>
#import <CHDatabaseKit/SBLibrary+Calendars.h>
#import <CHDatabaseKit/SBLibrary+Colors.h>
#import <CHDatabaseKit/SBLibrary+Folders.h>
#import <CHDatabaseKit/SBLibrary+Forms.h>
#import <CHDatabaseKit/SBLibrary+Icons.h>
#import <CHDatabaseKit/SBLibrary+Keywords.h>
#import <CHDatabaseKit/SBLibrary+Labels.h>
#import <CHDatabaseKit/SBLibrary+Links.h>
#import <CHDatabaseKit/SBLibrary+Notes.h>
#import <CHDatabaseKit/SBLibrary+Privileges.h>
#import <CHDatabaseKit/SBLibrary+Search.h>
#import <CHDatabaseKit/SBLibrary+Service.h>
#import <CHDatabaseKit/SBLibraryManager.h>
#import <CHDatabaseKit/SBOpenBaseNotificationHandler.h>
#import <CHDatabaseKit/PGNotificationCenter.h>

#import <CHDatabaseKit/CHDatabaseStopper.h>
#import <CHDatabaseKit/SBSpotlightMetadataUpdater.h>
#import <CHDatabaseKit/NSString+VExtensions.h>

#endif
