//
//  CHFormDefinition.h
//  CHAppKit
//
//  Created by Rod Schmidt on 1/10/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHFormFieldDefinition;

@interface CHFormDefinition : NSObject <NSCoding>
{
	long long		_rowID;
	NSString	*	_uuid;
	NSString *		_name;
	NSMutableArray *_fields;
}

-(id)init;
-(id)initWithRowID:(long long)rowID name:(NSString *)aName fields:(NSString *)fieldsXML uuid:(NSString *)uuid;

-(long long)rowID;
-(NSString *)uuid;

-(NSString *)name;
-(void)setName:(NSString *)aName;

-(NSString *)fieldsXML;
- (void)setFieldsXML:(NSString *)fieldsXML;
-(void)addField:(CHFormFieldDefinition *)aField;
-(void)removeField:(CHFormFieldDefinition *)field;
-(void)removeAllFields;

-(NSEnumerator *)fieldEnumerator;
-(CHFormFieldDefinition *) fieldAtIndex:(unsigned int) index;
-(CHFormFieldDefinition *) fieldMatchingName:(NSString *) name;
-(int) indexOfField:(CHFormFieldDefinition *) fieldDef;

-(unsigned int)fieldCount;

@end
