//
//  CHFormFieldDefinition.h
//  CHAppKit
//
//  Created by Rod Schmidt on 1/10/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum
{
	CHFormFieldTypeText,
	CHFormFieldTypeNumber,
	CHFormFieldTypeDate,
	CHFormFieldTypeBoolean
} 
CHFormFieldType;

typedef enum
{
	CHFormFieldDateToday,
	CHFormFieldDateTomorrow,
	CHFormFieldDateNextWeek,
	CHFormFieldDateOther = 10
}
CHFormFieldDateDefault;

@interface CHFormFieldDefinition : NSObject <NSCoding, NSCopying>
{
	NSString *				_label;
	CHFormFieldType			_type;
	id						_defaultValue;
	BOOL					_isDecimal;
	int						_numberOfDecimalPlaces;
	CHFormFieldDateDefault	_dateDefault;
	int						_numberOfLines;
}

+(id)fieldDefinition;

-(id)init;
-(id)initWithLabel:(NSString *)aLabel type:(CHFormFieldType)aType;

-(id)copyWithZone:(NSZone *)aZone;

-(NSString *)label;
-(void)setLabel:(NSString *)aLabel;

-(CHFormFieldType)type;
-(void)setType:(CHFormFieldType)aType;

-(id)defaultValue;
-(NSString *)defaultValueString;
-(void)setDefaultValue:(id)aValue;

-(BOOL)isDecimal;
-(void)setIsDecimal:(BOOL)decimal;

-(int)numberOfDecimalPlaces;
-(void)setNumberOfDecimalPlaces:(int)places;

-(CHFormFieldDateDefault)dateDefault;
-(void)setDateDefault:(CHFormFieldDateDefault)aDateDefault;

-(int)numberOfLines;
-(void)setNumberOfLines:(int)lines;

@end
