//
//  DBEntity+CHExtensions.h
//  CHOpenBaseAPI
//
//  Created by Nick Zitzmann on 08/11/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenBaseAPI/DBEntity.h>

@interface DBEntity (CHExtensions)
- (DBRecord *)selectRecord:(NSString *)keyValue keyColumnName:(NSString *)keyColumn usingConnection:(OpenBase *)connection;
- (DBRecord *)selectRecordWithRowID:(long long)rowID usingConnection:(OpenBase *)connection;
- (NSMutableArray *)selectRecordsWith:(NSString *)whereStatement orderBy:(NSString *)orderBy usingConnection:(OpenBase *)connection;

- (BOOL)updateRecordsWith:(NSString *)whereStatement set:(NSString *)setStatement usingConnection:(OpenBase *)connection;

- (BOOL)deleteRecordWithRowID:(long long)rowID usingConnection:(OpenBase *)connection;
- (BOOL)deleteRecordsWith:(NSString *)whereStatement usingConnection:(OpenBase *)connection;
- (BOOL)deleteAllRecordsUsingConnection:(OpenBase *)connection;	// WARNING: Very dangerous method, don't use unless you know what you're doing!

- (int)recordCountUsingConnection:(OpenBase *)connection;
- (int)recordCountWhere:(NSString *)whereStatement usingConnection:(OpenBase *)connection;
@end
