//
//  DBRecord+CHExtensions.h
//  CHOpenBaseAPI
//
//  Created by Nick Zitzmann on 08/11/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <OpenBaseAPI/DBRecord.h>

@interface DBRecord (CHExtensions)
// Workarounds
- (NSCalendarDate *)dateForColumn:(int)column;	// the difference between these methods and -dateValueForColumn: etc. is these methods return nil if the column data itself is nil; for some odd reason, as of OpenBase 9.0 b20, DBRecord returns a nonsense date if the -dateValueForColumn: method is called and the column data is actually nil
- (NSCalendarDate *)dateForColumnName:(NSString *)columnName;

// Shortcuts
- (void)setString:(NSString *)newStringValue forColumn:(int)theColumn substituteNilForEmptyString:(BOOL)substitute;
- (void)setString:(NSString *)newStringValue forColumnName:(NSString *)columnName substituteNilForEmptyString:(BOOL)substitute;
- (void)setURL:(NSURL *)url forColumn:(int)column;
- (void)setURL:(NSURL *)url forColumn:(int)column substituteNilForEmptyString:(BOOL)substitute;
- (void)setURL:(NSURL *)url forColumnName:(NSString *)columnName;
- (void)setURL:(NSURL *)url forColumnName:(NSString *)columnName substituteNilForEmptyString:(BOOL)substitute;
- (NSURL *)URLForColumn:(int)column;
- (NSURL *)URLForColumnName:(NSString *)columnName;

// Extensions
- (DBRecord *)duplicateWithConnection:(OpenBase *)connection;
- (NSDictionary *)recordDictionary;

@end
