//
//  OpenBase+CHExtensions.h
//  CHOpenBaseAPI
//
//  Created by Nick Zitzmann on 08/11/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <OpenBaseAPI/OpenBase.h>

// Constants
extern NSString * const CHOBReplicationTargetHost;
extern NSString * const CHOBReplicationTargetPassword;
extern NSString * const CHOBReplicationTargetDatabase;
extern NSString * const CHOBReplicationTableName;

@interface OpenBase (CHExtensions)
// Testers
+ (BOOL)isOBInstalled;
+ (BOOL)isOBRunning;
- (BOOL)isNewDatabase;

// Accessors
- (int)columnForColumnName:(const char *)columnName;	// intended to be used with a buffer after -executeCommand and -nextRow
- (NSString *)groupNameString;	// WARNING - Clears command buffer when called, don't use while building a command
- (NSString *)serverIDString;
- (BOOL)tableExistsWithName:(NSString *)name;	// this method also clears the command buffer
- (NSArray *)tableNames;
- (NSString *)softwareId;
- (void)setSoftwareId:(NSString *)newSoftwareId;

// Shortcuts
- (BOOL)connectToDatabaseString:(NSString *)pgDBName onHost:(NSString *)pgHostName login:(NSString *)pgLoginName password:(NSString *)pgPassword return:(int *)pgReturnCode;
- (void)makeCommandString:(NSString *)commandString;
- (void)makeCommandFormat:(NSString *)format, ...;
- (BOOL)reloadProcedures;
- (NSString *)serverMessageString;
- (BOOL)backupToDestinationPath:(NSString *)path;

// User management
- (BOOL)changePassword:(NSString *)newPassword forUser:(NSString *)aUser;

// Replication
- (BOOL)setupReplicationWithHostName:(NSString *)aHostName password:(NSString *)aPassword databaseName:(NSString *)aDatabaseName;	// deprecated, don't use
- (BOOL)setupReplicationWithHostName:(NSString *)aHostName password:(NSString *)aPassword databaseName:(NSString *)aDatabaseName tableNames:(NSArray *)tableNamesToReplicate;
- (BOOL)setupReplicationWithHostName:(NSString *)aHostName password:(NSString *)aPassword databaseName:(NSString *)aDatabaseName tableName:(NSString *)aTableName;
- (BOOL)hasReplicationConfiguration;
- (NSArray *)replicationConfiguration;	// returns array of NSDictionary objects; keys listed above in Constants
- (BOOL)teardownReplicationWithHostName:(NSString *)aHostName databaseName:(NSString *)aDatabaseName;	// tears down synchronization for _all_ tables in the database
- (BOOL)teardownReplicationWithHostName:(NSString *)aHostName databaseName:(NSString *)aDatabaseName tableName:(NSString *)aTableName;

// Misc. helpers
+ (NSString *)gnutarLocation;
@end
