//
//  PGAddressBookManager.h
//  CHDatabaseKit
//
//  Created by Jerry Halls on Tue Jan 27 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class PGAddressBook, PGAddressBookLocal;

extern NSString * const PGAddressBookWasAddedNotification;
extern NSString * const PGAddressBookWasRemovedNotification;

@interface PGAddressBookManager : NSObject
{
	NSMutableArray  *_addressBookArray;
}
+ (id)sharedAddressBookManager;

- (BOOL)isAddressBookManaged:(PGAddressBook*)aAddressBook;
- (BOOL)isAddressBookNameManaged:(NSString*)aNameString;
- (BOOL)isAlreadyConnectedToDatabase:(NSDictionary *)databaseConnectionInfo;	// used by PGAddressBookRemote to determine if we're already connected to the remote database

- (BOOL)addAddressBook:(PGAddressBook*)aAddressBook;
- (BOOL)removeAllAddressBooks;
- (BOOL)removeAddressBook:(PGAddressBook*)aAddressBook;

- (NSArray *)addressBooks;
- (PGAddressBookLocal*)addressBookLocal;
- (NSArray *)remoteAddressBooks;
- (PGAddressBook *)getAddressBookByID:(NSString *)idString userID:(NSString *)userID;
- (NSArray *)getAddressBooksByID:(NSString *)anIDString;
- (NSArray *)getAddressBooksByClass:(Class)abClass;
- (NSArray *)getConnectedAddressBooksByClass:(Class)abClass;

@end
