//
//  PGCalendarAttendee.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/15/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PGCalendarEnums.h"
#import "PGCalendarEventTaskAttribute.h"

@class PGRecord;

@interface PGCalendarAttendee : PGCalendarEventTaskAttribute <NSCoding, NSCopying>
{
	NSMutableArray *_delegatedFromEmails;
	NSMutableArray *_delegatedToEmails;
}
- (NSURL *)attendeeURL;
- (void)setAttendeeURL:(NSURL *)newURL;

- (NSString *)commonName;
- (void)setCommonName:(NSString *)newCommonName;

- (NSMutableArray *)delegatedFromEmailAddresses;
- (void)addFromDelegateEmailAddress:(NSString *)emailAddress;
- (void)removeFromDelegateEmailAddress:(NSString *)emailAddress;
- (void)setFromDelegateEmailAddresses:(NSArray *)addresses;

- (NSMutableArray *)delegatedToEmailAddresses;
- (void)addToDelegateEmailAddress:(NSString *)emailAddress;
- (void)removeToDelegateEmailAddress:(NSString *)emailAddress;
- (void)setToDelegateEmailAddresses:(NSArray *)addresses;

- (NSString *)emailAddress;
- (void)setEmailAddress:(NSString *)newAddress;

- (PGCalendarAttendeeRole)role;
- (void)setRole:(PGCalendarAttendeeRole)newRole;

- (BOOL)requiresRSVP;
- (void)setRequiresRSVP:(BOOL)newRSVP;

- (PGCalendarAttendeeStatus)status;
- (void)setStatus:(PGCalendarAttendeeStatus)newStatus;

- (PGCalendarAttendeeUserType)userType;
- (void)setUserType:(PGCalendarAttendeeUserType)newUserType;

- (PGRecord *)localRecord;
- (void)setLocalRecord:(PGRecord *)aRecord;

@end
