//
//  PGCalendarFieldStrings.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/27/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// Important note: Unlike with people & groups, you don't normally use these field strings to get values from properties inside our model calendar objects. Whenever possible, you should use their accessor methods instead. We've implemented a keyed model for these classes mainly to solve problems that are not easy to solve without a keyed model.

// Used by a variety of objects:
extern NSString * const PGCalendarUniqueIDProperty;			// NSString
extern NSString * const PGCalendarRowIDProperty;			// long long
extern NSString * const PGCalendarVersionProperty;			// long
extern NSString * const PGCalendarDatabaseIDProperty;		// NSString
extern NSString * const PGCalendarDatabaseUserIDProperty;	// NSString
extern NSString * const PGCalendarURLProperty;				// NSURL
extern NSString * const PGCalendarDescriptionProperty;		// NSString
extern NSString * const PGCalendarDescriptionBlobIDProperty;	// NSString; this string is used internally and should not be used by applications
extern NSString * const PGCalendarSummaryProperty;			// NSString
extern NSString * const PGCalendarCreatedDateProperty;		// NSCalendarDate
extern NSString * const PGCalendarModifiedDateProperty;		// NSCalendarDate

// Used by PGCalendar:
extern NSString * const PGCalendarTitleProperty;							// NSString
extern NSString * const PGCalendarNotesProperty;							// NSString
extern NSString * const PGCalendarIsReadOnlyProperty;						// BOOL
extern NSString * const PGCalendarColorStringProperty;						// NSString containing a color in Chronos String Representation format
//extern NSString * const PGCalendarNSCalendarProperty;	// NSCalendar
extern NSString * const PGCalendarNSCalendarIdentifierProperty;				// NSString
extern NSString * const PGCalendarPublishSubscribeStatusProperty;			// int
extern NSString * const PGCalendarPublishSubscribeExcludeMaskProperty;		// long
extern NSString * const PGCalendarPublishSubscribeRefreshIntervalProperty;	// long long
extern NSString * const PGCalendarPublishSubscribeLastRefreshProperty;		// NSDate
extern NSString * const PGCalendarPublishSubscribePublishTitleProperty;		// NSString

// Used by PGCalendarEvent and PGCalendarTask:
extern NSString * const PGCalendarClassificationProperty;	// PGCalendarClassification (unsigned int)
extern NSString * const PGCalendarStatusProperty;			// PGCalendarEventStatus/PGCalendarTaskStatus (unsigned int)
extern NSString * const PGCalendarPriorityProperty;			// unsigned int between 0 and 9 (0=none, 1=highest, 9=lowest)
extern NSString * const PGCalendarOriginalDateProperty;		// NSCalendarDate
extern NSString * const PGCalendarStartDateProperty;		// NSCalendarDate
extern NSString * const PGCalendarIsAllDayProperty;			// BOOL

// Used by PGCalendarEvent:
extern NSString * const PGCalendarLocationProperty;			// NSString
extern NSString * const PGCalendarEndDateProperty;			// NSCalendarDate

// Used by PGCalendarTask:
extern NSString * const PGCalendarDueDateProperty;				// NSCalendarDate
extern NSString * const PGCalendarDueDateIsDateOnlyProperty;	// BOOL
extern NSString * const PGCalendarCompletionDateProperty;		// NSCalendarDate

// Used by PGCalendarAlarm:
extern NSString * const PGCalendarAlarmRepeatCountProperty;		// unsigned int
extern NSString * const PGCalendarAlarmRepeatIntervalProperty;	// unsigned int
extern NSString * const PGCalendarAlarmRelativityProperty;		// PGCalendarAlarmRelativity (unsigned int)
extern NSString * const PGCalendarAlarmTriggerDateProperty;		// NSCalendarDate
extern NSString * const PGCalendarAlarmTriggerDurationProperty;	// NSCalendarDate

// Used by PGCalendarAudioAlarm:
extern NSString * const PGCalendarAlarmSoundNameProperty;		// NSString
extern NSString * const PGCalendarAlarmShouldDisplayMessage;	// BOOL

// Used by PGCalendarExecuteAlarm:
extern NSString * const PGCalendarAlarmFileAliasProperty;		// NDAlias
extern NSString * const PGCalendarAlarmIsScriptProperty;		// BOOL

// Used by PGCalendarAttendee:
extern NSString * const PGCalendarAttendeeCommonNameProperty;	// NSString
extern NSString * const PGCalendarAttendeeEmailProperty;		// NSString
extern NSString * const PGCalendarAttendeeRoleProperty;			// PGCalendarAttendeeRole (unsigned int)
extern NSString * const PGCalendarAttendeeRequiresRSVPProperty;	// BOOL
extern NSString * const PGCalendarAttendeeStatusProperty;		// PGCalendarAttendeeStatus (unsigned int)
extern NSString * const PGCalendarAttendeeUserTypeProperty;		// PGCalendarAttendeeUserType (unsigned int)
extern NSString * const PGCalendarAttendeeLocalRecordProperty;	// PGRecord

// Used by PGRecurrence:
extern NSString * const PGRecurrenceEndProperty;			// PGRecurrenceEnd (unsigned int)
extern NSString * const PGRecurrenceNumberOfTimesProperty;	// unsigned int
extern NSString * const PGRecurrenceFrequencyProperty;		// PGRecurrenceFrequency (unsigned int)
extern NSString * const PGRecurrenceIntervalProperty;		// unsigned int
extern NSString * const PGRecurrenceEndDateProperty;		// NSCalendarDate
extern NSString * const PGRecurrenceByDayFreqProperty;		// NSArray of NSNumber objects
extern NSString * const PGRecurrenceByDayDaysProperty;		// NSArray of NSNumber objects
extern NSString * const PGRecurrenceByMonthProperty;		// NSArray of NSNumber objects
extern NSString * const PGRecurrenceByMonthDayProperty;		// NSArray of NSNumber objects
extern NSString * const PGRecurrenceBySetPositionProperty;	// NSArray of NSNumber objects
extern NSString * const PGRecurrenceByWeekNumberProperty;	// NSArray of NSNumber objects
extern NSString * const PGRecurrenceByYearDayProperty;		// NSArray of NSNumber objects

// Used by PGCalendarOrganizer:
extern NSString * const PGCalendarOrganizerCommonNameProperty;		// NSString
extern NSString * const PGCalendarOrganizerEmailProperty;			// NSString
extern NSString * const PGCalendarOrganizerLocalRecordProperty;		// PGPerson
extern NSString * const PGCalendarOrganizerLocalRecordIDProperty;	// NSNumber

// Pasteboard:
extern NSString * const PGCalendarsPboardType;
extern NSString * const PGCalendarEventsPboardType;	// archived NSArray with NSDictionary objects; key "event" is a PGCalendarEvent, key "startDate" is an NSDate
extern NSString * const PGCalendarTasksPboardType;	// archived NSArray with PGCalendarTask objects
extern NSString * const PGCalendarEventsAndTasksPboardType;	// archived NSArray with PGCalendarOccurrableRecord objects
