//
//  PGCalendarOccurrableRecord.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/27/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PGCalendarRecord.h"

@class PGCalendar, PGCalendarAlarm, PGCalendarAttendee, PGRecurrence, PGCalendarOrganizer;

@interface PGCalendarOccurrableRecord : PGCalendarRecord <NSCoding, NSCopying>
{
	long long _calendarID;
	PGCalendar *_unsavedCalendar;
	long long _parentRecordID;
	PGCalendarOccurrableRecord *_unsavedParentRecord;
	
	CHMutableLongLongIndexSet *_detachedOccurrenceIDs;
	NSMutableArray *_unsavedDetachedOccurrences;
	CHMutableLongLongIndexSet *_alarmIDs;
	NSMutableArray *_unsavedAlarms;
	CHMutableLongLongIndexSet *_attendeeIDs;
	NSMutableArray *_unsavedAttendees;
	CHMutableLongLongIndexSet *_recurrenceIDs;
	NSMutableArray *_unsavedRecurrences;
	PGCalendarOrganizer *_organizer;
}
- (NSComparisonResult)compare:(PGCalendarOccurrableRecord *)record;

- (PGCalendar *)calendar;
- (void)setCalendar:(PGCalendar *)newRelatedCalendar;
- (PGCalendarOccurrableRecord *)parentRecord;

- (BOOL)addDetachedOccurrence:(PGCalendarOccurrableRecord *)aRecord;
- (NSArray *)detachedOccurrences;
- (BOOL)removeDetachedOccurrence:(PGCalendarOccurrableRecord *)aRecord;

- (BOOL)addAlarm:(PGCalendarAlarm *)anAlarm;
- (NSArray *)alarms;
- (BOOL)removeAlarm:(PGCalendarAlarm *)anAlarm;

- (BOOL)addAttendee:(PGCalendarAttendee *)attendee;
- (NSArray *)attendees;
- (BOOL)removeAttendee:(PGCalendarAttendee *)attendee;

- (BOOL)addRecurrence:(PGRecurrence *)aRecurrence;
- (NSArray *)recurrences;
- (BOOL)removeRecurrence:(PGRecurrence *)aRecurrence;

- (PGCalendarOrganizer *)organizer;
- (void)setOrganizer:(PGCalendarOrganizer *)organizer;

- (NSCalendarDate *)startDate;
- (NSString *)summary;

@end
