//
//  PGCalendarRecord.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/21/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHFoundation/CHFoundation.h>

@interface PGCalendarRecord : NSObject <CHFastSearching, NSCoding, NSCopying>
{
	NSMutableDictionary *_properties;
	NSString *_databaseID;	// the database ID and user ID are very frequently fetched and are thus not stored in _properties
	NSString *_databaseUserID;
}
- (id)initWithUniqueId:(NSString *)uniqueId;

- (NSString *)uniqueId;
- (void)setUniqueId:(NSString *)aUniqueId;
- (long long)rowID;
- (void)setRowID:(long long)rowID;
- (long)version;
- (void)setVersion:(long)version;
- (NSString *)databaseID;
- (NSString *)databaseUserID;

- (BOOL)boolValueForProperty:(NSString *)property;
- (long)longValueForProperty:(NSString *)property;
- (long long)longLongValueForProperty:(NSString *)property;
- (NSArray *)properties;
- (void)removeValueForProperty:(NSString *)property;
- (void)setBoolValue:(BOOL)value forProperty:(NSString *)property;
- (void)setLongValue:(long)value forProperty:(NSString *)property;
- (void)setLongLongValue:(long long)value forProperty:(NSString *)property;
- (void)setValue:(id)value forProperty:(NSString *)property;
- (void)setUnsignedIntValue:(unsigned int)value forProperty:(NSString *)property;
- (id)valueForProperty:(NSString *)property;
- (unsigned int)unsignedIntValueForProperty:(NSString *)property;

@end
