//
//  PGCalendarSearchSession.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 6/4/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PGSearchEnums.h"

extern NSString * const PGCalendarSearchSessionEventsDidUpdateNotification;
extern NSString * const PGCalendarSearchSessionEventsDidFinishNotification;
extern NSString * const PGCalendarSearchSessionTasksDidUpdateNotification;
extern NSString * const PGCalendarSearchSessionTasksDidFinishNotification;

@interface PGCalendarSearchSession : NSObject <NSCopying>
{
	PGSearchLogic _logic;
	NSMutableArray *_criteria;
	NSMutableArray *_operatorTypes;
	NSMutableArray *_searchItems;
	NSMetadataQuery *_eventQuery;
	NSSet *_cachedEventSearchResults;
	NSMetadataQuery *_taskQuery;
	NSSet *_cachedTaskSearchResults;
	unsigned int _options;
}
+ (PGCalendarSearchSession *)searchSessionWithLogic:(PGSearchLogic)someLogic criteria:(PGCalendarSearchCriteria)aCriteria operatorType:(NSPredicateOperatorType)anOperatorType item:(NSString *)anItem;

- (PGSearchLogic)logic;
- (void)setLogic:(PGSearchLogic)newLogic;
- (void)addCriteria:(PGCalendarSearchCriteria)newCriteria operatorType:(NSPredicateOperatorType)operatorType item:(NSString *)newItem;  // we're one-way mutable; at this time there is no need for a remove method
- (unsigned)count;
- (NSArray *)criteriaArray;
- (PGCalendarSearchCriteria)criteriaAtIndex:(unsigned)index;
- (NSArray *)operatorTypeArray;
- (NSPredicateOperatorType)operatorTypeAtIndex:(unsigned)index;
- (NSArray *)itemArray;
- (NSString *)itemAtIndex:(unsigned)index;
- (unsigned int)options;
- (void)setOptions:(unsigned int)options;	// options are NSComparisonPredicate options

- (NSPredicate *)predicateForSpotlight;
- (NSPredicate *)predicateForUsesOtherThanSpotlight;
- (BOOL)startEventQuery;
- (NSSet *)uniqueIDsOfFoundEvents;
- (BOOL)startTaskQuery;
- (NSSet *)uniqueIDsOfFoundTasks;
- (BOOL)isQuerying;

@end
