//
//  PGCalendarTask.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/13/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PGCalendarEnums.h"
#import "PGCalendarOccurrableRecord.h"

@interface PGCalendarTask : PGCalendarOccurrableRecord <NSCoding, NSCopying>
{
	NSMutableArray *_exceptionDates;
}
- (NSString *)taskDescription;
- (void)setTaskDescription:(NSString *)newTaskDescription;

- (NSString *)summary;	// this is the "title" of the task
- (void)setSummary:(NSString *)newSummary;

- (PGCalendarClassification)classification;
- (void)setClassification:(PGCalendarClassification)newClassification;

- (PGCalendarTaskStatus)status;
- (void)setStatus:(PGCalendarTaskStatus)newStatus;

- (unsigned int)priority;
- (void)setPriority:(unsigned int)newPriority;

- (NSCalendarDate *)originalDate;
- (void)setOriginalDate:(NSCalendarDate *)newOriginalDate;

- (NSCalendarDate *)startDate;
- (void)setStartDate:(NSCalendarDate *)newStartDate;

- (NSCalendarDate *)dueDate;
- (void)setDueDate:(NSCalendarDate *)newDueDate;

- (BOOL)dueDateIsDateOnly;
- (void)setDueDateIsDateOnly:(BOOL)newDueDate;

- (NSCalendarDate *)completionDate;
- (void)setCompletionDate:(NSCalendarDate *)newCompletionDate;

- (NSArray *)exceptionDates;
- (void)setExceptionDates:(NSArray *)newExceptionDates;
- (void)addExceptionDate:(NSCalendarDate *)newExceptionDate;
- (void)removeExceptionDate:(NSCalendarDate *)exceptionDate;

- (NSURL *)url;
- (void)setURL:(NSURL *)newURL;

@end
