//
//  PGFieldStrings.h
//  Organizer
//
//  Created by Jerry Halls on Wed Feb 04 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

/*****************
 Keys for PGRecord
 *****************/

extern NSString * const PGFieldRowID;				// NSNumber containing a long long
extern NSString * const PGFieldUniqueID;			// NSString
extern NSString * const PGFieldVersion;				// NSNumber containing a long
extern NSString * const PGFieldCreatedDate;			// NSCalendarDate
extern NSString * const PGFieldModifiedDate;		// NSCalendarDate
extern NSString * const PGFieldDatabaseID;			// NSString
extern NSString * const PGFieldDatabaseUserID;		// NSString

/****************
 Keys for PGGroup
 ****************/

extern NSString * const PGFieldGroupName;			// NSString

/*****************
 Keys for PGPerson
 *****************/

extern NSString * const PGFieldFirstName;			// NSString
extern NSString * const PGFieldFirstNamePhonetic;   // NSString
extern NSString * const PGFieldMiddleName;			// NSString
extern NSString * const PGFieldMiddleNamePhonetic;  // NSString
extern NSString * const PGFieldLastName;			// NSString
extern NSString * const PGFieldLastNamePhonetic;	// NSString
extern NSString * const PGFieldNameOrdering;		// NSNumber containing int
enum
{
	PGFieldNOUseDefault = 0,
	PGFieldNOFirstNameFirst,
	PGFieldNOLastNameFirst
};

extern NSString * const PGFieldJobTitle;				// NSString
extern NSString * const PGFieldDepartment;				// NSString
extern NSString * const PGFieldOrganization;			// NSString
extern NSString * const PGFieldOrganizationsID;			// NSString, points to other contact's unique ID
extern NSString * const PGFieldOrganizationPhonetic;	// NSString
extern NSString * const PGFieldIsCompany;				// NSNumber containing BOOL
extern NSString * const PGFieldTickerSymbol;			// NSString
extern NSString * const PGFieldHobby;					// NSString

extern NSString * const PGFieldTitle;				// NSString
extern NSString * const PGFieldSuffix;				// NSString
extern NSString * const PGFieldNickname;			// NSString
extern NSString * const PGFieldMaidenName;			// NSString
extern NSString * const PGFieldShortName;			// NSString

extern NSString * const PGFieldNotes;				// NSString

extern NSString * const PGFieldAddresses;			// PGMultiValue with each value being an NSDictionary
extern NSString * const PGFieldPhoneNumbers;		// PGMultiValue with each value being an NSString
extern NSString * const PGFieldEmailAddresses;		// PGMultiValue with each value being an NSString
extern NSString * const PGFieldURLs;				// PGMultiValue with each value being an NSURL
extern NSString * const PGFieldIMAIM;				// PGMultiValue with each value being an NSString
extern NSString * const PGFieldIMICQ;				// PGMultiValue with each value being an NSString
extern NSString * const PGFieldIMJabber;			// PGMultiValue with each value being an NSString
extern NSString * const PGFieldIMMSN;				// PGMultiValue with each value being an NSString
extern NSString * const PGFieldIMYahoo;				// PGMultiValue with each value being an NSString
extern NSString * const PGFieldOtherDates;			// PGMultiValue with each value being an NSCalendarDate
extern NSString * const PGFieldRelatedNames;		// PGMultiValue with each value being an NSString
extern NSString * const PGFieldCustomField;			// PGMultiValue with each value being an NSString

extern NSString * const PGFieldPrefNamePane;		// NSNumber containing long

/**********************************
 Keys for PGRecord (list view only)
 **********************************/

extern NSString * const PGFieldCreatedUserID;		// NSNumber containing a long long
extern NSString * const PGFieldModifiedUserID;		// NSNumber containing a long long

/***********************
 Labels for PGMultiValue
 ***********************/

extern NSString * const PGLabelHome;				// NSString; generic label
extern NSString * const PGLabelWork;				// NSString; generic label
extern NSString * const PGLabelMobile;				// NSString; generic label
extern NSString * const PGLabelOther;				// NSString; generic label
extern NSString * const PGLabelHomeFAX;				// NSString; for FAX phone numbers
extern NSString * const PGLabelWorkFAX;				// NSString; for FAX phone numbers
extern NSString * const PGLabelPager;				// NSString; for phone numbers
extern NSString * const PGLabelMain;				// NSString; for phone numbers
extern NSString * const PGLabelBirthdate;			// NSCalendarDate; for other dates
extern NSString * const PGLabelAnniversary;			// NSCalendarDate; for other dates
extern NSString * const PGLabelMother;				// NSString; for related names
extern NSString * const PGLabelFather;				// NSString; for related names
extern NSString * const PGLabelParent;				// NSString; for related names
extern NSString * const PGLabelSister;				// NSString; for related names
extern NSString * const PGLabelBrother;				// NSString; for related names
extern NSString * const PGLabelChild;				// NSString; for related names
extern NSString * const PGLabelFriend;				// NSString; for related names
extern NSString * const PGLabelSpouse;				// NSString; for related names
extern NSString * const PGLabelPartner;				// NSString; for related names
extern NSString * const PGLabelAssistant;			// NSString; for related names
extern NSString * const PGLabelManager;				// NSString; for related names
extern NSString * const PGLabelHomePage;			// NSString; for URLs

extern NSString * const PGLabelKeyword;				// NSString; for custom fields (used in Keywords block in SOHO Contacts)
extern NSString * const PGLabelBirthplace;			// NSString; for custom fields
extern NSString * const PGLabelSchoolAttended;		// NSString; for custom fields
extern NSString * const PGLabelStudentID;			// NSString; for custom fields
extern NSString * const PGLabelFavoriteFood;		// NSString; for custom fields
extern NSString * const PGLabelBusinessHours;		// NSString; for custom fields
extern NSString * const PGLabelTagline;				// NSString; for custom fields

/**************************************
 NSDictionary keys for PGFieldAddresses
 **************************************/
extern NSString * const PGAddressStreetKey;			// NSString; lines delimited by \n
extern NSString * const PGAddressCityKey;			// NSString
extern NSString * const PGAddressStateKey;			// NSString
extern NSString * const PGAddressPostalCodeKey;		// NSString
extern NSString * const PGAddressCountryKey;		// NSString
extern NSString * const PGAddressCountryCodeKey;	// NSString
extern NSString * const PGAddressRegionKey;			// NSString

/*****************************************
 NSDictionary keys for PGFieldRelatedNames
 *****************************************/
extern NSString * const PGRelatedNameKey;			// NSString
extern NSString * const PGRelatedNameIDKey;			// NSString; contains the unique ID of a contact


/****************
 Pasteboard types
 ****************/

extern NSString * const PGContactCardsPboardType;
extern NSString * const PGContactGroupsPboardType;
