//
//  PGNotificationCenter.h
//  Organizer
//
//  Created by Nick Zitzmann on 03/04/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

// People updates
extern NSString * const PGPeopleWereAddedNotification;
extern NSString * const PGPeopleWereModifiedNotification;
extern NSString * const PGPeopleWereDeletedNotification;
extern NSString * const PGHistoryBlockFilesWereChangedNotification;
extern NSString * const PGHistoryBlockFilesWereDeletedNotification;

// Group updates
extern NSString * const PGGroupsWereAddedNotification;
extern NSString * const PGGroupsWereModifiedNotification;
extern NSString * const PGGroupsWereDeletedNotification;

// People/group updates (user info keys)
extern NSString * const PGOriginalRecordsKey;
extern NSString * const PGRecordsKey;	// when posting a PGPeopleWereAddedNotification or PGPeopleWereModifiedNotification notification through PGNotificationCenter, put updated records into the userInfo of this key; the PGNotificationCenter will split them into the following two user info keys
extern NSString * const PGFullRecordsKey;
extern NSString * const PGListViewRecordsKey;
extern NSString * const PGDeletedRowIDsKey;

// Calendar updates
extern NSString * const PGCalendarsWereAddedNotification;
extern NSString * const PGCalendarsWereModifiedNotification;
extern NSString * const PGCalendarsWereDeletedNotification;
extern NSString * const PGCalendarEventsWereAddedNotification;
extern NSString * const PGCalendarEventsWereModifiedNotification;
extern NSString * const PGCalendarEventsWereDeletedNotification;
extern NSString * const PGCalendarTasksWereAddedNotification;
extern NSString * const PGCalendarTasksWereModifiedNotification;
extern NSString * const PGCalendarTasksWereDeletedNotification;
extern NSString * const PGCalendarAlarmsWereAddedNotification;
extern NSString * const PGCalendarAlarmsWereModifiedNotification;
extern NSString * const PGCalendarAlarmsWereDeletedNotification;
extern NSString * const PGCalendarAttendeesWereAddedNotification;
extern NSString * const PGCalendarAttendeesWereModifiedNotification;
extern NSString * const PGCalendarAttendeesWereDeletedNotification;
extern NSString * const PGCalendarRecurrencesWereAddedNotification;
extern NSString * const PGCalendarRecurrencesWereModifiedNotification;
extern NSString * const PGCalendarRecurrencesWereDeletedNotification;
extern NSString * const PGCalendarOrganizersWereAddedNotification;
extern NSString * const PGCalendarOrganizersWereDeletedNotification;
extern NSString * const PGCalendarOrderingWasModifiedNotification;

// Calendar updates (user info keys)
extern NSString * const PGCalendarRecordsKey;
extern NSString * const PGDeletedCalendarRowIDsKey;

@interface PGNotificationCenter : NSObject
{
	NSNotificationCenter *_nc;
	
}
+ (PGNotificationCenter *)defaultCenter;

- (void)postNotificationName:(NSString *)name object:(id)object;
- (void)postNotificationName:(NSString *)name object:(id)object userInfo:(NSDictionary *)userInfo;
- (void)postNotificationNameOnMainThread:(NSString *)name object:(id)object waitUntilDone:(BOOL)waitUntilDone;
- (void)postNotificationNameOnMainThread:(NSString *)name object:(id)object userInfo:(NSDictionary *)userInfo waitUntilDone:(BOOL)waitUntilDone;

@end
