//
//  PGPerson.h
//  Organizer
//
//  Created by Jerry Halls on Tue Jan 27 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CHFoundation/CHFoundation.h>
#import "PGRecord.h"

@class ABPerson;

typedef enum
{
	PGPersonFullPerson = 0,
	PGPersonAbridgedPerson,
	PGPersonListViewPerson
} PGPersonIsa;

@interface PGPerson : PGRecord <NSCoding, NSCopying>
{
	CHMutableLongLongIndexSet *_parentGroupIDs;
	NSData *_imageData;
	PGPersonIsa _pgisa;
	
	NSString *_firstName;
	NSString *_middleName;
	NSString *_lastName;
	NSString *_organization;
	NSNumber *_isCompany;
}
- (NSArray *)parentGroups;
- (NSData *)imageData;
- (void)setImageData:(NSData *)newImageData;
- (NSString *)fullName; // returns a string that can be displayed in the GUI containing a name for this person, returns the company name if the person is a company, returns a blank string if the person has no name (or is a company with no name)
- (NSString *)fullNameRegardlessOfCompany:(BOOL)includeOrganizationNameAtAll;  // returns a string containing a person name, even if the "person" is really a company (if includeOrganizationNameAtAll is YES), may return a blank string
- (void)flipNameOrdering;
- (PGPersonIsa)isa;
- (void)setIsa:(PGPersonIsa)newIsa;

@end
