//
//  PGRecord.h
//  Organizer
//
//  Created by Jerry Halls on Tue Jan 27 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CHFoundation/CHFoundation.h>

@interface PGRecord : NSObject <NSCoding, NSCopying, CHFastSearching>
{
	NSMutableDictionary *_propertiesDictionary;
}
+ (NSArray *)properties;	// this differs from the instance method in that it returns _all_ properies available for this class type rather than just the ones currently in use

- (id)initWithUniqueId:(NSString *)uniqueId;	// optional; call -init instead of this method to generate a new record with a UUID for a unique ID

- (void)setUniqueId:(NSString*)aUniqueID;
- (NSString *)uniqueId;
    // Convenience method to return the unique ID of a record.
    // Equivalent to -valueForProperty:kABUIDProperty

- (id)valueForProperty:(NSString *)property;
    // Returns the value of a given property. The type of the value depends on the property type.
    // The retuned object is immutable (NSString not NSMutableString, ABMultiValue not ABMutableMultiValue, etc..)

- (BOOL)setValue:(id)value forProperty:(NSString *)property;
    // Set the value of a given property. The type of the value must match the property type.

- (NSArray *)properties;

- (long long)rowID;	// returns 0 if the record has not been entered in the database
- (void)setRowID:(long long)rowID;

- (long)version;	// returns 0 if the record has not been entered in the database
- (void)setVersion:(long)version;

- (NSString *)databaseID;
- (NSString *)databaseUserID;

@end
