//
//  PGRecurrence.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 06/14/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "PGCalendarEnums.h"
#import "PGCalendarEventTaskAttribute.h"

@interface PGRecurrence : PGCalendarEventTaskAttribute <NSCoding, NSCopying>
{
	NSMutableArray *_byDayFreq;
	NSMutableArray *_byDayDays;
	NSMutableArray *_byMonth;
	NSMutableArray *_byMonthDay;
	NSMutableArray *_bySetPosition;
	NSMutableArray *_byWeekNumber;
	NSMutableArray *_byYearDay;
	
	PGRecurrenceEnd _end;
	PGRecurrenceFrequency _freq;
	unsigned int _interval;
}
- (PGRecurrenceEnd)end;
- (void)setEnd:(PGRecurrenceEnd)newEnd;

- (unsigned int)numberOfTimes;
- (void)setNumberOfTimes:(unsigned int)newNumberOfTimes;

- (PGRecurrenceFrequency)frequency;
- (void)setFrequency:(PGRecurrenceFrequency)newFrequency;

- (unsigned int)interval;
- (void)setInterval:(unsigned int)newInterval;

- (NSCalendarDate *)endDate;
- (void)setEndDate:(NSCalendarDate *)newEndDate;

- (BOOL)hasCustomizations;

- (void)addByDayFreq:(int)byDayFreq byDayDay:(PGCalendarWeekday)byDayDay;	// byDayFreq can be -1 or between 1 and 4, with 1 representing the first day of the week, 4 representing the fourth, and -1 representing the last
- (NSArray *)byDayFreq;
- (void)setByDayFreq:(NSArray *)newByDayFreq;
- (NSArray *)byDayDays;
- (void)setByDayDays:(NSArray *)newByDayDay;
- (void)addByMonth:(unsigned int)byMonth;
- (NSArray *)byMonth;
- (void)setByMonth:(NSArray *)newByMonth;
- (void)addByMonthDay:(int)byMonthDay;
- (NSArray *)byMonthDay;
- (void)setByMonthDay:(NSArray *)newByMonthDay;
- (void)addBySetPosition:(unsigned int)bySetPos;
- (NSArray *)bySetPosition;
- (void)setBySetPosition:(NSArray *)newBySetPosition;
- (void)addByWeekNumber:(int)byWeekNumber;
- (NSArray *)byWeekNumber;
- (void)setByWeekNumber:(NSArray *)newWeekNumber;
- (void)addByYearDay:(int)byYearDay;
- (NSArray *)byYearDay;
- (void)setByYearDay:(NSArray *)newByYearDay;

@end
