//
//  PGSpotlightMetadataUpdater.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 5/7/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CHFoundation/CHFoundation.h>

@class CHDatabase, PGAddressBook, PGCalendarOccurrableRecord, PGPerson;

@interface PGSpotlightMetadataUpdater : NSObject
{
	CHQueue *_threadQueue;
}
+ (PGSpotlightMetadataUpdater *)sharedUpdater;
+ (NSString *)organizerMetadataBaseFolderPath;

- (void)beginBackgroundMetadataUpdateForAddressBook:(PGAddressBook *)ab people:(NSArray *)people;
- (void)beginBackgroundMetadataUpdateForAddressBook:(PGAddressBook *)ab events:(NSArray *)events;
- (void)beginBackgroundMetadataUpdateForAddressBook:(PGAddressBook *)ab tasks:(NSArray *)tasks;
- (void)blockUntilUpdatesAreFinished;

- (BOOL)addMetadataForOccurrableRecord:(PGCalendarOccurrableRecord *)record;
- (BOOL)addMetadataForPerson:(PGPerson *)person;
- (BOOL)updateMetadataForOccurrableRecord:(PGCalendarOccurrableRecord *)record;
- (BOOL)updateMetadataForPerson:(PGPerson *)person;
- (BOOL)deleteMetadataForOccurrableRecordInAddressBook:(PGAddressBook *)ab rowID:(long long)rowID isEvent:(BOOL)isEvent;
- (BOOL)deleteMetadataForOccurrableRecordInDatabase:(CHDatabase *)db rowID:(long long)rowID isEvent:(BOOL)isEvent;
- (BOOL)deleteMetadataForPersonInAddressBook:(PGAddressBook *)ab rowID:(long long)rowID;
- (BOOL)deleteMetadataForPersonInDatabase:(CHDatabase *)db rowID:(long long)rowID;

- (void)deleteMetadataForAddressBook:(PGAddressBook *)ab;
- (void)deleteMetadataForDatabase:(CHDatabase *)db;
- (BOOL)deleteMetadataForLocalDatabases;

@end
