//
//  SBAlarmInfo.h
//  StickyBrainKit
//
//  Created by Rod Schmidt on Wed Jun 16 2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <Foundation/Foundation.h>

@class DBRecord;

@interface SBAlarmInfo : NSObject 
{
	long long		_alarmID;
	long long		_noteID;
	long long		_userID;
	NSCalendarDate* _dateTime;
	BOOL			_playAlarm;
	BOOL			_launchStickyBrain;
	BOOL			_critical;
	NSString*		_databaseID;
	NSString*		_dbUserID;
	NSString		*_uuid;
}

+(SBAlarmInfo*) alarmInfoFromRecord: (DBRecord*) record;

-(void) takeValuesFrom: (DBRecord*) record;

-(long long) alarmID;
-(long long) noteID;
-(long long) userID;
- (NSString *)uuid;
-(NSCalendarDate*) dateTime;
-(BOOL) justPlay;
-(BOOL) shouldDisplay;
-(BOOL) shouldPlay;
-(BOOL) shouldLaunch;
-(BOOL) isCritical;
-(NSString*) databaseID;
-(NSString*) databaseUserID;

-(void) setAlarmID: (long long) alarmID;
-(void) setNoteID: (long long) noteID;
-(void) setUserID: (long long) userID;
- (void)setUUID:(NSString *)uuid;
-(void) setDateTime: (NSCalendarDate*) dateTime;
-(void) setShouldPlay: (BOOL) play;
-(void) setShouldLaunch: (BOOL) launch;
-(void) setCritical: (BOOL) critical;

@end
