//
//  SBFolderHierarchy.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/4/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class SBFolder;

// Manages the hierarchy of folders in a SOHO Notes database. Any view that displays the folders
// Can use the shared instance of this class to display the folder hierarchy in a outline or table view

@interface SBFolderHierarchy : NSObject 
{
	SBFolder *	_root;
	BOOL		_includeSmartFolders;
}

+(SBFolderHierarchy *)sharedInstance;

-(BOOL) includeSmartFolders;
-(void) setIncludeSmartFolders:(BOOL) include;

-(void)rebuildHierarchy;

-(SBFolder *)childOfFolder: (SBFolder *)folder atIndex: (unsigned int)index;
-(unsigned int)insertPositionForFolder: (SBFolder *)aFolder newParent: (SBFolder *)parent;
-(unsigned int)numberOfChildrenOfFolder: (SBFolder *)aFolder;

@end
