//
//  SBLibrary+Folders.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/24/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SBLibrary.h"

@class SBFolder, SBSmartFolder;

@interface SBLibrary (Folders)

-(BOOL)addDefaultFolders;
-(SBFolder *)addNewFolder: (NSString *)folderName toParent: (SBFolder *)parent;
-(BOOL)addNewFolder: (SBFolder *)newFolder;
-(BOOL)addNewSmartFolder:(SBSmartFolder *)newFolder;
-(void) adjustNotesCountForFolder:(SBFolder *) folder notes:(NSArray *) notes 
					 notesDeleted:(int) notesDeleted notesRemoved:(int) notesRemoved;
-(NSArray *)arrayOfFolders;
-(NSArray *)arrayOfTopLevelFolders;
-(SBFolder *)dailyNotesFolder;
-(SBFolder *)defaultNotesFolder;
-(BOOL)deleteAllInFolder: (SBFolder *)folder progressDelegate: (id)delegate progressCallback: (SEL)progressCallbackSelector;
-(BOOL)deleteFolderAndContents: (SBFolder *)aFolder 
              progressDelegate: (id)delegate 
              progressCallback: (SEL)progressCallbackSelector;
-(NSArray *)folderIDsForFolder:(SBFolder *)folder;
-(NSArray*)folders;
-(NSArray *) foldersToIncludeInDock;
-(NSArray *)foldersWithShortcuts;
-(SBFolder *)folderWithID:(long long)folderID;
-(SBFolder *)folderWithName: (NSString *)name;
-(SBFolder *)folderWithType: (long long)folderTypeID;
-(SBFolder *)folderWithTypeNamed: (NSString *)typeName;
-(SBFolder *)folderWithUUID: (NSString *)uuid;
-(SBFolder *)iPodFolder;
-(BOOL)iPodFolderHasNotes;
-(BOOL)isTrashFolder: (SBFolder *)folder;
-(BOOL)isUnfiledFolder: (SBFolder *)aFolder;
-(SBFolder *)journalFolder;
-(SBFolder *)libraryFolder;
-(void)loadFolders;
-(SBFolder *)mainFolder;
-(BOOL)moveFolders: (NSArray *)folders to: (SBFolder *)newParent;
-(SBFolder *)palmFolder;
-(SBFolder *)passwordsFolder;
-(SBFolder *)receiptsFolder;
-(BOOL)renameFolder: (SBFolder *)folder to: (NSString *)newName;
-(void)resetSmartFolders;
-(BOOL)setIcon: (long long)iconID forFolder: (SBFolder *)folder;
-(SBFolder *)trashFolder;
-(SBFolder *)unfiledFolder;
-(BOOL)updateDefaultsForFolder: (SBFolder *)folder;
-(void)updateFolderNoteCounts;
-(void)updateNoteCountForFolder: (SBFolder *)folder;
-(void)updateNoteCountForFolder: (SBFolder*) folder recurse: (BOOL) recurse;
-(BOOL)updateSmartFolder:(SBSmartFolder *)folder;

// OpenBase notifications:
//	This methods are called by the SBOpenBaseNotificationHandler to tell the library about
//	external changes
//
-(void)folderWasAddedExternally:(long long)rowid;
-(void)folderWasChangedExternally:(long long)rowid;
-(void)folderWasDeletedExternally:(long long)rowid;

@end
