//
//  SBLibrary+Links.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/24/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SBLibrary.h"

@interface SBLibrary (Links)

-(NSArray *)abPeopleLinkedToNote: (SBNote *)note;
-(NSDictionary *) linksForNoteIDs:(CHLongLongIndexSet *) noteIDs;
-(NSDictionary *)linksForNotes: (NSArray *)notes inBooks: (NSArray *)bookIDs;
-(BOOL)linkNotes: (NSArray *)notes toNote: (SBNote *)note;
	// person can be either an ABPerson or PGPerson
-(BOOL)linkNotes: (NSArray *)notes toPerson: (id)person;
-(NSArray *)linkNotesAndReturnNoteLinkInfoObjects: (NSArray *)notes toPerson: (PGPerson *)person;
-(CHLongLongIndexSet *) noteIDsLinkedToNote:(SBNote *) note;
-(NSArray *)notesLinkedToNote: (SBNote *)note;
-(NSArray *)pgPeopleLinkedToNote:(SBNote *)note;
-(BOOL)removeLinkToNote: (SBNote *)linkedNote fromNote: (SBNote *)srcNote;
-(BOOL)removeLinkToNotes: (NSArray *)notes fromNote: (SBNote *)srcNote;
	// person can be either an ABPerson or PGPerson
-(BOOL)removeLinkToNotes: (NSArray *)notes fromPerson: (id)person;	

@end
