//
//  SBLibrary+Search.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 3/28/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SBLibrary.h"

@interface SBLibrary (Search)

/*
 Retrieve the notes assigned to a folder that contain some text using a spotlight query
 
 Parameters
 searchText		The text to look for
 folder			The folder to which the notes are assigned
 contact		The contact the notes are assigned to, can be either an ABPerson or PGPerson contact. May be nil if no contact
 keys           The names of the notes attributes to load. Nil to get all attributes
 sortedBy		The name of the attribute to sort the notes by
 descending		Yes if the notes should be sorted in descending order
 searchOptions	Options for the search like case insensitive, etc.
 privateNotes	Yes if private notes should be loaded
 */
-(void)startQueryForNotesWithText: (NSString *)searchText 
						   folder: (SBFolder *)folder 
						  contact: (id)contact
							 keys: (NSArray *)keys
						 sortedBy: (NSString *)sortKey 
					   descending: (BOOL)descending 
					 privateNotes: (BOOL)privateNotes
				 onlyFlaggedNotes: (BOOL)onlyFlaggedNotes
					searchOptions: (SearchOptions) options;

-(void)startQueryForNotesWithText:(NSString *)searchText 
					 privateNotes:(BOOL)privateNotes 
						  folders:(NSArray *)folders;

-(void)stopQuery;

@end
