//
//  SBLibrary+Service.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/5/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SBLibrary.h"
#import "SBNote.h"

@interface SBLibrary (Service)

// General
///////////

-(BOOL)arePrivatesVisible;
-(NSArray *)buildMenuDataForService: (BOOL)aIncludePrivateNotes;

// Folders
///////////

-(NSArray *)foldersForService;
-(long long)getPasswordsFolderID;
-(long long)getReceiptsFolderID;
-(NSArray *)searchResults: (NSString *)aSearchString showPrivates: (BOOL)aShowPrivates 
			   forFolders: (NSArray *)aFoldersArray;
-(void)startSearchQueryForString:(NSString *)aSearchString showPrivates: (BOOL)aShowPrivates 
					  forFolders:(NSArray *)aFoldersArray;

// Notes
/////////

-(NSData *) getContentsForNoteID:(long long) aNoteID hasWindowType:(SBWindowType *)aWindowType hasURL:(NSURL **) aURL 
					   hasFormID:(long long *) aFormID success:(BOOL *)aSuccess;
-(NSMutableArray *)notesWithActions: (BOOL)grabActions includePrivateNotes: (BOOL)includePrivateNotes 
						folderArray: (NSArray *)folderArray;

-(NSDictionary *)noteWithURLInPasswordsFolder: (NSString *)aURLString;

@end
