//
//  SBNoteLinkInfo.h
//  CHDatabaseKit
//
//  Created by Nick Zitzmann on 10/26/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class PGPerson, SBNote;

/* What is SBNoteLinkInfo?
SBNoteLinkInfo is currently used to facilitate linking between contacts and notes when
synchronizing changes with the Truth. Unfortunately there's a bug in Tiger Sync Services
that prohibits our sync schema from directly linking to an entity in another schema. So we must
use this structure to represent a link between a contact and a note, while storing a "mini-
contact" of type com.chronos.notes.Contact in the Truth that contains some information about
the contact so we can re-link the contact and the note when pulling the Truth. */

@interface SBNoteLinkInfo : NSObject
{
	NSString *_uuid;
	PGPerson *_person;
	SBNote *_note;
}
+ (id)noteLinkInfoWithUUID:(NSString *)uuid person:(PGPerson *)person note:(SBNote *)note;

- (id)initWithUUID:(NSString *)uuid person:(PGPerson *)person note:(SBNote *)note;

- (NSString *)uuid;
- (PGPerson *)person;
- (SBNote *)note;

@end
