//
//  SBNotesCache.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/19/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHDatabase, SBFolder, SBNote;

@interface SBNotesCache : NSObject 
{
	CHDatabase *_database;
	NSMutableDictionary *_notes;
	NSMutableDictionary *_noteFoldersMap;
	NSMutableDictionary *_folderNotesMap;
}

-(id)initWithDatabase:(CHDatabase *)db;

-(void)reset;
-(void)refreshNoteFolders;
-(BOOL)needToPrime;

-(void)addNote:(SBNote *)note;
-(CHLongLongIndexSet *)allNoteIDs;
-(NSArray *)allNotes;
-(SBNote *)noteWithID:(long long)noteID;
-(NSArray *)notesWithIDs:(NSArray *)noteIDs;
- (NSArray *)notesWithIDIndexes:(CHLongLongIndexSet *)noteIDs;
-(NSArray *)notesInFolders:(NSArray *)folderIDs;
-(void)refreshNoteWithID:(long long)noteID;
-(void)removeNoteWithID:(long long)noteID;

-(void)assignNoteID:(long long)noteID toFolderID:(long long)folderID;
-(void)unassignNoteID:(long long)noteID fromFolderID:(long long)folderID;
-(void)unassignNoteIDFromAllFolders:(long long)noteID;

-(CHLongLongIndexSet *)IDsOfFoldersContainingNote:(long long)noteID;
-(CHLongLongIndexSet *)IDsOfNotesInFolder:(long long)folderID;
-(CHLongLongIndexSet *)IDsOfNotesInFolders:(NSArray *)folderIDs;

// Remove all references to the folder in the maps
-(void)removeFolderReferences:(long long)folderID;

-(unsigned int) noteCountForFolder:(long long) folderID;

@end
