//
//  SBSmartFolder.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 10/30/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SBFolder.h"
#import "SBSmartFolderRule.h"

extern NSString * const SBSmartFolderResultsReadyNotification;
extern NSString * const SBSmartFolderMoreResultsReadyNotification;

@interface SBSmartFolder : SBFolder <NSCoding>
{
	NSArray *_rules;
	SBSearchLogic _logic;
	NSMetadataQuery *_query;
	NSMutableArray *_notes;
}

+(id)folderWithName: (NSString *)name databaseID: (NSString *)dbID userID: (NSString *)userID;

-(id)initWithName: (NSString *)name databaseID: (NSString *)dbID userID: (NSString *)userID;

-(SBSearchLogic)logic;
-(void)setLogic:(SBSearchLogic)logic;

-(NSArray *)rules;
-(void)setRules: (NSArray *)rules;

-(BOOL)isSmartFolder;

-(NSPredicate *)predicate;

-(void)startQuery;
-(BOOL)queryRunning;

-(NSArray *)notes;
-(void)setNotes:(NSArray *)notes;

-(int) notesCount;


@end
