//
//  SBSpotlightMetadataUpdater.h
//  CHDatabaseKit
//
//  Created by Rod Schmidt on 3/29/06.
//  Copyright 2006 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// Implements a background process that looks for notes that have changed 
// and keeps the Spotlight metadata up to date.

@class SBSpotlight;
@class SBNote;
@class CHDatabase;

@interface SBSpotlightMetadataUpdater : NSObject 
{
	SBSpotlight*	_spotlight;
	NSMutableArray*	_threads;
}

+(SBSpotlightMetadataUpdater*) sharedUpdater;

-(void) startUpdatingMetadataForDatabase: (CHDatabase*) db;
-(void) startUpdatingMetadataForNotesWithIDs: (NSArray*) noteIDs inDatabase: (CHDatabase*) db;
-(void) stopUpdatingMetadataForDatabase: (CHDatabase*) db;
-(void) stopUpdatingMetadataForAllDatabases;

-(BOOL) addMetadataForNote: (SBNote*) aNote;
-(BOOL) deleteMetadataForNoteID: (long long) noteID inDatabase: (CHDatabase*) db;
-(BOOL) updateMetadataForNote: (SBNote*) aNote;
-(BOOL) deleteInvalidUserSpotlights;

-(void) deleteAllExistingMetadata;
-(void) deleteAllExistingMetadataForDatabase: (CHDatabase*) db;
-(void) deleteMetadataForLocalDatabases;
-(void) deleteMetadataForNotesWithIDs: (NSArray*) noteIDs inDatabase: (CHDatabase*) db;

-(void) reimportAllMetadata;

@end
