//
//  StickyBrainProtocol.h
//
//  Created by Rod Schmidt on Tue Oct 03 2006.
//  Copyright (c) 2006 Chronos, LC. All rights reserved.
//

// Protocol for service to talk to SOHO Notes
@protocol StickyBrainProtocol
-(oneway void) openNoteInOwnWindow: (long long) aNoteID;
-(oneway void) selectFolderInViewer: (long long) folderID;
@end

// Protocol for SOHO Notes to talk to service
@protocol StickyBrainServiceProtocol
-(oneway void) disableHotKeys;
-(oneway void) dockNoteOpenWhenDraggingToPreferenceChanged: (int) newLocation;
-(oneway void) dockNotePositionPreferenceChanged: (int) newPosition;
-(oneway void) dockNoteShowAllFoldersPreferenceChanged: (BOOL) showAllFolders;
-(oneway void) dockNoteWidthPreferenceChanged: (float) newWidth;
-(oneway void) enableDockNotePreferenceChanged: (BOOL) enabled;
-(oneway void) enableHotKeys;
-(oneway void) isQuickNoteFloatingPreferenceChanged: (BOOL) isFloating;
-(oneway void) isFlashNoteFloatingPreferenceChanged: (BOOL) isFloating;
-(oneway void) showMenuBarIconPreferenceChanged: (BOOL) showIcon;
-(oneway void) standardHotKeyChanged;
-(oneway void) stickBrainUserDefaultsChanged;
-(oneway void) terminateApp;
-(oneway void) URLHandlingPreferenceChanged:(int)newDefault;
-(oneway void) clipboardLimitPreferenceChanged:(int) clipboardLimitTag;
-(int) deletedTransactionCountWithNewLimit:(int) clipboardLimitTag;
-(oneway void) autoHideDownloadsPreferenceChanged:(BOOL) autoHide;
-(oneway void) autoHideDockNotePreferenceChanged:(BOOL) autoHide;
@end

