//
//  CHCURL.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 3/7/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <curl/curl.h>
#import <Security/SecTrust.h>

extern NSString * const CHCURLErrorDomain;

// Note: This is an abstract superclass in need of a concrete implementation.

@interface CHCURL : NSObject
{
	CURL *_curlPtr;
	struct curl_slist *_httpHeaders;
	NSURLRequest *_request;
	NSString *_username;
	NSString *_password;
	char *_failureReason;
}
+ (void)setGlobalCertificateDelegate:(Class)delegate;
- (id)initWithRequest:(NSURLRequest *)request user:(NSString *)username password:(NSString *)password;	// designated initializer

- (NSURLRequest *)request;
- (NSError *)errorForCURLResult:(CURLcode)result;	// helper method for turning CURLcodes into NSErrors

@end

// WARNING: -prepareCURL and -performCURL **must** be performed using the same autorelease pool! If the autorelease pool is drained in between, then CHCURL will not function correctly because the autorelease pool contains the string data, draining the pool will delete the data, and CURL does not copy string pointers.

@interface CHCURL (SubclassesOnly)
- (void)prepareCURL;	// invoke the superclass to set up proxy data, etc.
- (void)performCURL;	// do not invoke the superclass
@end


@interface NSObject (CHCURLGlobalDelegate)
+ (BOOL)curl:(CHCURL *)curl certificateTrustCheckFailed:(SecTrustRef)trust;	// called when a certificate fails a check; do not invoke the superclass
@end
