//
//  CHCalendarEvent.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 9/28/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol CHCalendarEvent <NSCoding, NSCopying, NSObject>
- (NSString *)summary;
- (NSCalendarDate *)startDate;
- (void)setStartDate:(NSCalendarDate *)startDate;
- (NSCalendarDate *)endDate;
- (void)setEndDate:(NSCalendarDate *)endDate;
- (BOOL)isAllDay;
- (void)setAllDay:(BOOL)newAllDay;
- (NSCalendarDate *)nextOccurrenceOfEventAfterDate:(NSDate *)date;
- (NSCalendarDate *)previousOccurrenceOfEventBeforeDate:(NSDate *)date;
- (BOOL)hasAlarms;
- (BOOL)hasAttendees;
- (BOOL)hasRecurrences;
@end

@interface CHCalendarEvent : NSObject <CHCalendarEvent>
{
	NSString *_title;
	NSCalendarDate *_startDate;
	NSCalendarDate *_endDate;
	BOOL _isAllDay;
}
- (void)setSummary:(NSString *)summary;

@end
