//
//  CHDAVManager.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 4/3/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString * const CHDAVManagerErrorDomain;

@interface CHDAVManager : NSObject
{
	NSMutableDictionary *_runners;
	NSLock *_davManagerLock;
}
+ (CHDAVManager *)sharedManager;

// The following methods work with HTTP, HTTPS, FTP, FTPS, and SFTP:
- (BOOL)createDirectoryAtURL:(NSURL *)url user:(NSString *)username password:(NSString *)password error:(NSError **)error;
- (BOOL)deleteFileAtURL:(NSURL *)url user:(NSString *)username password:(NSString *)password error:(NSError **)error;

// The following methods only work with HTTP and HTTPS:
- (NSDictionary *)HTTPOptionsAtURL:(NSURL *)url user:(NSString *)username password:(NSString *)password error:(NSError **)error;
- (NSData *)makeCalendarAtURL:(NSURL *)url XMLHTTPRequest:(NSString *)xml user:(NSString *)username password:(NSString *)password error:(NSError **)error;
- (NSData *)propertiesAtURL:(NSURL *)url XMLHTTPRequest:(NSString *)xml user:(NSString *)username password:(NSString *)password error:(NSError **)error;
- (NSData *)reportAtURL:(NSURL *)url XMLHTTPRequest:(NSString *)xml user:(NSString *)username password:(NSString *)password error:(NSError **)error;
- (NSData *)setPropertiesAtURL:(NSURL *)url XMLHTTPRequest:(NSString *)xml user:(NSString *)username password:(NSString *)password error:(NSError **)error;

@end
