//
//  CHDebugRecursiveLock.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 10/13/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

/* Here's how this class works:
This class is used to debug situations where the software is not balancing its locks and unlocks
correctly. If the software unlocks more than it locks, then we'll raise an exception. If the
software locks more than it unlocks, then the extra lock(s) can be detected by calling the
-printStatus method. The method will log a backtrace pointing out the last lock attempt that
was not balanced with an unlock. */

@interface CHDebugRecursiveLock : NSRecursiveLock
{
	NSMutableArray *_stackTraces;
}
- (void)printStatus;

@end
