/*
 *  CHGeometryTools.h
 *  CHFoundation
 *
 *  Created by Nick Zitzmann on 03/30/2005.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include <Foundation/Foundation.h>

FOUNDATION_STATIC_INLINE CFRange CHConvertNSRangeToCFRange(NSRange range)
{
	CFRange returnValue;
	
	returnValue.location = range.location;
	returnValue.length = range.length;
	return returnValue;
}


#ifdef CGFLOAT_DEFINED
#if CGFLOAT_IS_DOUBLE == 1
#define CHCGCeil(x) ceil(x)
#define CHCGFloor(x) floor(x)
#else
#define CHCGCeil(x) ceilf(x)
#define CHCGFloor(x) floorf(x)
#endif
#endif

FOUNDATION_STATIC_INLINE NSPoint CHCenterOfRect(NSRect rect) { return NSMakePoint(NSMidX(rect), NSMidY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHTopCenterOfRect(NSRect rect) { return NSMakePoint(NSMidX(rect), NSMaxY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHBottomCenterOfRect(NSRect rect) { return NSMakePoint(NSMidX(rect), NSMinY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHLeftCenterOfRect(NSRect rect) { return NSMakePoint(NSMinX(rect), NSMidY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHRightCenterOfRect(NSRect rect) { return NSMakePoint(NSMaxX(rect), NSMidY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHBottomLeftOfRect(NSRect rect) { return rect.origin; }
FOUNDATION_STATIC_INLINE NSPoint CHBottomRightOfRect(NSRect rect) { return NSMakePoint(NSMaxX(rect), NSMinY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHTopLeftOfRect(NSRect rect) { return NSMakePoint(NSMinX(rect), NSMaxY(rect)); }
FOUNDATION_STATIC_INLINE NSPoint CHTopRightOfRect(NSRect rect) { return NSMakePoint(NSMaxX(rect), NSMaxY(rect)); }
