//
//  CHLongLongIndexSet.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 2/9/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#ifndef NSINTEGER_DEFINED
#import "CHObjCRuntime.h"
#endif

struct CHLongLongIndexSetList
{
	long long index;
	struct CHLongLongIndexSetList *next;
};

enum
{
	CHLongLongNotFound = 0x7fffffffffffffffLL
};

@interface CHLongLongIndexSet : NSObject <NSCoding, NSCopying, NSMutableCopying>
{
	struct CHLongLongIndexSetList *_reserved;
	struct CHLongLongIndexSetList *_bookmark;
}
+ (id)indexSet;
+ (id)indexSetWithIndex:(long long)index;

- (id)initWithIndex:(long long)index;

- (BOOL)containsIndex:(long long)index;
- (NSUInteger)count;
- (long long)firstIndex;
- (long long)lastIndex;
- (long long)indexGreaterThanIndex:(long long)index;
- (long long)indexLessThanIndex:(long long)index;
- (BOOL)isEqualToIndexSet:(CHLongLongIndexSet *)indexSet;

- (NSString *)indexesJoinedByString:(NSString *)separator;

@end

@interface CHMutableLongLongIndexSet : CHLongLongIndexSet
{
	
}
- (void)addIndex:(long long)index;
- (void)addIndexes:(CHLongLongIndexSet *)indexSet;
- (void)removeIndex:(long long)index;
- (void)removeIndexes:(CHLongLongIndexSet *)indexSet;
- (void)removeAllIndexes;

@end
