//
//  CHQueue.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 03/17/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface CHQueue : NSObject
{
	NSMutableArray *_queue;
	NSConditionLock *_queueLock;
	NSMutableArray *_queueProcessors;
	NSLock *_queueProcessorsLock;
	BOOL _shuttingDownProcessors;
}

- (id)initWithNumberOfQueueProcessors:(unsigned int)numberOfProcessors;	// this is not the designated initializer; it's only a shortcut for -init followed by -startQueueProcessors:

- (void)enqueueInvocation:(NSInvocation *)anInvocation;
- (void)enqueueTarget:(id)target selector:(SEL)selector;
- (void)enqueueTarget:(id)target selector:(SEL)selector withObject:(id)anObject;

- (void)startQueueProcessors:(unsigned int)numberOfProcessors;

- (NSInvocation *)nextInvocationInQueue;	// this is used by the queue processor; outside of it please do not invoke this method directly

@end
