//
//  CHTrie.h
//  CHFoundation
//
//  Created by Rod Schmidt on 1/3/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHTrieNode;

@interface CHTrie : NSObject 
{
	CHTrieNode *_root;
}

-(void)addString:(NSString *)aString;
-(NSArray *)findStringsWithPrefix:(NSString *)prefix;
-(BOOL)removeString:(NSString *)aString;

-(void)log;

@end

@interface CHTrieNode : NSObject
{
	unichar					_key;
	NSMutableDictionary *	_children;
	BOOL					_isWord;	// we have a word at this point
}

-(id)initWithKey:(unichar)aKey;

-(NSComparisonResult)compare:(CHTrieNode *)aNode;
-(BOOL)isEqual:(id)anObject;

-(void)addString:(NSString *)aString position:(int)position;

-(CHTrieNode *)findString:(NSString *)aString position:(int)position;

-(BOOL)removeString:(NSString *)aString position:(int)position;

// return all the full strings stored below the node
-(NSArray *)stringsWithPrefix:(NSString *)prefix;

-(void)log;

@end
