//
//  CHURLUpload.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 2/13/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CHCURL.h"
#import "CHObjCRuntime.h"

@interface CHURLUpload : CHCURL
{
	NSString *_localFilePath;
	NSFileHandle *_fileHandle;
	unsigned long long _fileSize;
	id _nonretainedDelegate;
	BOOL _sentDidBegin;
	NSLock *_threadLock;
	BOOL _shouldCancel;
}
- (id)initWithRequest:(NSURLRequest *)request localFilePath:(NSString *)path delegate:(id)delegate;
- (id)initWithRequest:(NSURLRequest *)request localFilePath:(NSString *)path user:(NSString *)username password:(NSString *)password delegate:(id)delegate;
- (void)cancel;
- (NSString *)localFilePath;

@end

@interface NSObject (CHURLDelegate)
- (void)upload:(CHURLUpload *)upload didFailWithError:(NSError *)error;
- (void)upload:(CHURLUpload *)upload didSendDataOfLength:(NSUInteger)length;
- (void)uploadDidBegin:(CHURLUpload *)upload;
- (void)uploadDidFinish:(CHURLUpload *)upload;
@end
