//
//  NSAttributedString+CHExtensions.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 03/30/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSAttributedString (CHExtensions)
+ (id)attributedString;
+ (id)attributedStringWithString:(NSString *)aString attributes:(NSDictionary *)theAttributes;
+ (NSAttributedString *)ellipse;
- (NSAttributedString *)attributedStringByAddingAttribute:(NSString *)name value:(id)value;
- (NSAttributedString *)attributedStringByAddingAttribute:(NSString *)name value:(id)value range:(NSRange)aRange;
-(NSAttributedString*) stripWhitespaceByTruncating: (BOOL) truncate maxLength: (int) maxLength;
@end

@interface NSMutableAttributedString (CHExtensions)
- (void)appendString:(NSString *)aString;
- (void)appendString:(NSString *)aString attributes:(NSDictionary *)theAttributes;
- (void)deleteLastCharacter;
- (void)insertString:(NSString *)aString atIndex:(unsigned)index;
- (void)insertString:(NSString *)aString atIndex:(unsigned)index attributes:(NSDictionary *)theAttributes;
- (void)setString:(NSString *)aString;
- (void)setString:(NSString *)aString attributes:(NSDictionary *)theAttributes;
@end
