//
//  NSCalendar+CHExtensions.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 08/01/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#ifndef NSINTEGER_DEFINED
#import "CHObjCRuntime.h"
#endif

#if MAC_OS_X_VERSION_10_4 <= MAC_OS_X_VERSION_MAX_ALLOWED
#define CHBasicDateCalendarUnits (NSEraCalendarUnit | NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit)
#define CHTimeCalendarUnits (NSHourCalendarUnit | NSMinuteCalendarUnit | NSSecondCalendarUnit)
#define CHCalendarMaxDays	42
#define CHCalendarEmptyDay	-1

@interface NSCalendar (CHExtensions)
+ (id)calendarWithCalendarIdentifier:(NSString *)identifier;
+ (NSCalendar *)fastCurrentCalendar;	// like +currentCalendar but it's considerably faster when called during a loop
+ (NSCalendar *)nonLeakyCurrentCalendar;	// like +currentCalendar but it doesn't leak memory

- (NSUInteger)lastWeekday;
- (NSInteger *)layoutOfMonthForDate:(NSDate *)date;	// pointer is CHCalendarMaxDays long; WARNING: return value will be deallocated when the autorelease pool is emptied
- (NSArray *)shortWeekdayNames;
- (NSArray *)weekdayNames;
@end
#endif
