//
//  NSDate+CHExtensions.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 03/30/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#ifndef NSINTEGER_DEFINED
#import "CHObjCRuntime.h"
#endif

@interface NSDate (CHExtensions)
+ (NSDate *)dateFromCalendarDate:(NSCalendarDate *)calendarDate;
+ (id)dateWithTimeInterval:(NSTimeInterval)seconds sinceDate:(NSDate *)refDate;
@end

@interface NSCalendarDate (CHExtensions)
+ (NSCalendarDate *)calendarDateFromDate:(NSDate *)date;
+ (NSCalendarDate *)calendarDateFromDate:(NSDate *)date withZone:(NSZone *)zone;

- (NSCalendarDate *)dateToNextHour;
- (NSCalendarDate *)dateWithCurrentTime;
- (NSCalendarDate *)dateWithoutCurrentTime;
#ifndef __LP64__
- (BOOL)isLeapYear;	// deprecated, don't use
- (int)numberOfDaysInMonth;	// deprecated, don't use
#endif
- (NSInteger)secondOfDay;
- (NSInteger)secondOfHour;
@end
