//
//  NSFileManager+CHExtensions.h
//  CHFoundation
//
//  Created by Rod Schmidt on 9/23/05.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Foundation/Foundation.h>
#ifndef NSINTEGER_DEFINED
#import "CHObjCRuntime.h"
#endif

@interface NSFileManager (CHExtensions)

// Create all the directories of a path
-(NSString*) createDirectoryPath: (NSString*) aPathString;
- (NSUInteger)directoryCountAtPath:(NSString *)path;
-(BOOL) ensureDirectoryPathExists: (NSString*) aDirectoryPathString;
-(BOOL) ensureFilePathExists:(NSString*)aFilePathString;
- (NSString *)findSystemFolderType:(int)folderType forDomain:(int)domain;	// folderType and domain are documented in CarbonCore/Folders.h; they are the same arguments one would feed to FSFindFolder()
- (NSArray *)fullPathDirectoryContentsAtPath:(NSString *)path;	// this is similar to -directoryContentsAtPath: but it returns full path strings
-(NSString*)uniqueFilename:(NSString*)aFilenameString atPath:(NSString*)aPathString;

@end
