//
//  NSString+CHExtensions.h
//  CHFoundation
//
//  Created by Nick Zitzmann on 03/30/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#ifndef NSINTEGER_DEFINED
#import "CHObjCRuntime.h"
#endif

@interface NSString (CHExtensions)
+ (id)ellipse;
+ (id)stringWithCharacter:(unichar)aChar;
+ (id)stringWithData:(NSData *)data encoding:(NSStringEncoding)encoding;
+ (id)stringWithData:(NSData *)data textEncodingName:(NSString *)teName;
+ (id)stringWithFileSystemRepresentation:(const char *)string;
+ (id)stringWithPascalString:(Str255)pascalString encoding:(NSStringEncoding)encoding;
- (BOOL)beginsWithString:(NSString *)aString;
- (BOOL)beginsWithString:(NSString *)aString options:(unsigned)options;	// "options" in these methods are defined in NSString.h as NSCaseInsensitiveSearch, etc.
- (size_t)byteCount;
- (NSComparisonResult)compareVersionStrings:(NSString *)otherString;
- (BOOL)containsString:(NSString *)aString;
- (BOOL)containsString:(NSString *)aString options:(unsigned)options;
- (BOOL)endsWithString:(NSString *)aString;
- (BOOL)endsWithString:(NSString *)aString options:(unsigned)options;
- (NSData *)hexStringData;
- (id)initWithCharacter:(unichar)aChar;
- (id)initWithData:(NSData *)data textEncodingName:(NSString *)teName;
- (id)initWithPascalString:(Str255)pascalString encoding:(NSStringEncoding)encoding;
#if MAC_OS_X_VERSION_MIN_REQUIRED <= MAC_OS_X_VERSION_10_4
- (NSInteger)integerValue;
#endif
- (BOOL)isEmpty;
- (BOOL)isEqualToString:(NSString *)aString options:(unsigned)options;
- (BOOL)isLowercase;
- (BOOL)isUppercase;
- (BOOL)isURL;
- (long)longValue;
- (NSArray *)longLongComponentsSeparatedByString:(NSString *)separator;	// takes an NSString of numbers with a separator; returns an NSArray of NSNumbers with long longs
#if MAC_OS_X_VERSION_MIN_REQUIRED <= MAC_OS_X_VERSION_10_4
- (long long)longLongValue;
#endif
- (NSString *)lowercaseSpacedString;
- (NSUInteger)numberOfOccurrencesOfCharacterInString:(unichar)aChar;
- (ConstStringPtr)pascalStringUsingEncoding:(NSStringEncoding)encoding;
- (ConstStringPtr)pascalStringUsingEncoding:(NSStringEncoding)encoding maxLength:(NSInteger)length;
- (NSRange)rangeOfCharactersFromSet:(NSCharacterSet *)aSet;
- (NSRange)rangeOfCharactersFromSet:(NSCharacterSet *)aSet options:(unsigned int)mask;
- (NSRange)rangeOfCharactersFromSet:(NSCharacterSet *)aSet options:(unsigned int)mask range:(NSRange)aRange;
- (NSString *)SGMLEncodedString;
- (NSString *)stringByAddingPercentEscapesUsingEncoding:(NSStringEncoding)encoding charactersToLeaveUnescaped:(NSString *)characters legalURLCharactersToBeEscaped:(NSString *)legalURLCharacters;
- (NSString *)stringByReplacingOccurrencesOfString:(NSString *)target withString:(NSString *)replacement;
- (NSString *)stringByResolvingAliasesInPath;
- (NSString *)stringByRaisingCaseOfFirstCharacter;
- (NSString *)stringByTrimmingWhitespace;
- (NSString *)stringForUseInHTTPGetArguments;
- (NSString *)escapedSQLString;
- (NSString *)substringWithoutRange:(NSRange)aRange;
- (unsigned int)unsignedIntValue;
@end

@interface NSMutableString (CHExtensions)
- (void)appendCharacter:(const unichar)character;
- (void)appendCharacters:(const unichar *)characters length:(NSUInteger)length;
- (void)deleteCharacterAtIndex:(NSUInteger)index;
- (void)deleteLastCharacter;
- (NSUInteger)replaceOccurrencesOfString:(NSString *)target withString:(NSString *)replacement;
- (NSUInteger)replaceOccurrencesOfString:(NSString *)target withString:(NSString *)replacement options:(unsigned)opts;
- (void)escapeForSQL;
@end
