//
//  CHDBWindowController.h
//  CHOpenBaseGUI
//
//  Created by Robert McCullough on 10/3/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// User default keys
extern NSString *CHDBWindowMode;
extern NSString *CHDBWindowHelpShowing;
extern NSString *CHDBWindowUserSize;
extern NSString *CHDBWindowAdminSize;
extern NSString *CHDBWindowUserSizeIncludesHelp;
extern NSString *CHDBWindowAdminSizeIncludesHelp;
extern NSString *CHDBWindowAdminPopupTag;

enum {
	CHDBWindowDefaultMode = 0,
	CHDBWindowUserMode,
	CHDBWindowSharingMode
};

enum {
	CHDBCalendarsPopupTag = 0,		// These are used when remembering/restoring the last selected type in the Admin view
	CHDBContactsPopupTag,
	CHDBNotesPopupTag
};

@interface CHDBWindowController : NSWindowController 
{
	IBOutlet NSView *_openingView;
	IBOutlet NSView *_userView;
	IBOutlet NSView *_adminView;
	
	IBOutlet NSButton *_userButton;
	IBOutlet NSButton *_adminButton;
	
	IBOutlet NSBox *_userBox;
	IBOutlet NSBox *_adminBox;
	
	IBOutlet NSButton *_openingHelpButton;
	IBOutlet NSTextField *_openingHelpLabel;
	IBOutlet NSButton *_userHelpButton;
	IBOutlet NSTextField *_userHelpLabel;
	IBOutlet NSButton *_adminHelpButton;
	IBOutlet NSTextField *_adminHelpLabel;
	
	IBOutlet NSScrollView *_openingHelpView;
	IBOutlet NSScrollView *_userHelpView;
	IBOutlet NSScrollView *_adminHelpView;
	
	NSToolbar *_toolbar;
	
	int _mode;
	BOOL _helpShowing;
}

+ (id)instance;

	//- (void)setSelectedDatabase:(CHDatabase*)db;

- (IBAction)modeButtonAction:(id)sender;
- (IBAction)helpButtonAction:(id)sender;
- (IBAction)goBackButtonAction:(id)sender;
- (IBAction)goToUserAction:(id)sender;
- (IBAction)goToAdministratorAction:(id)sender;

- (void)toggleHelpAndDisplay:(BOOL)display;

@end
