//
//  CHFormEditorWindowController.h
//  CHAppKit
//
//  Created by Rod Schmidt on 1/30/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHControlBar;
@class CHSplitView;
@class CHFormEditorView;
@class CHFormDefinition;

// Controls the window for managing all the forms in an application
//
@interface CHFormEditorWindowController : NSWindowController 
{
	IBOutlet NSOutlineView *	_formsView;
	IBOutlet CHControlBar *		_controlBar;
	IBOutlet NSButton *			_addButton;
	IBOutlet NSPopUpButton *	_actionButton;
	IBOutlet CHSplitView *		_splitter;
	IBOutlet NSWindow *			_newFormSheet;
	IBOutlet NSButton *			_newFormOKButton;
	IBOutlet NSTextField *		_newFormNameField;
	IBOutlet CHFormEditorView *	_formEditor;
	IBOutlet id					_delegate;
	IBOutlet id					_dataSource;
	IBOutlet NSScrollView *		_scrollView;

	id					_splitterDelegate;
	NSMutableArray *	_forms;
}

-(id)init;

// Get/Set the datasource for the form editor windows forms outline view. It must implement the required methods
// in the NSOutlineViewDataSource informal protocol.
-(id)dataSource;
-(void)setDataSource:(id)aDataSource;

-(id)delegate;
-(void)setDelegate:(id)aDelegate;

-(IBAction)newForm:(id)sender;
-(IBAction)endNewFormSheet:(id)sender;
-(IBAction)renameForm:(id)sender;
-(IBAction)delete:(id)sender;

-(void)refresh;

@end

// This interface contains methods in addition to the methods in NSOutlineViewDataSource
@interface NSObject (CHFormEditorWindowControllerDataSource)

-(void)formEditorWindow:(CHFormEditorWindowController *)editor addForm:(CHFormDefinition *)formDef parent:(id)parent;
-(BOOL)formEditorWindow:(CHFormEditorWindowController *)editor shouldDeleteForm:(CHFormDefinition *)formDef parent:(id)parent;
-(void)formEditorWindow:(CHFormEditorWindowController *)editor deleteForm:(CHFormDefinition *)formDef parent:(id)parent;
-(void)formEditorWindow:(CHFormEditorWindowController *)editor updateForm:(CHFormDefinition *)formDef parent:(id)parent;

@end

