//
//  CHFormView.h
//  CHAppKit
//
//  Created by Rod Schmidt on 1/10/07.
//  Copyright 2007 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHFormDefinition;

@interface CHFormView : NSView 
{
	IBOutlet NSPanel *	_calendarPanel;
	IBOutlet id			_delegate;
	
	CHFormDefinition *		_formDef;
	NSMutableArray *		_fields;
	BOOL					_canEdit;
	NSScrollView *			_scrollView;
}

-(CHFormDefinition *)formDefinition;
-(void)setFormDefinition:(CHFormDefinition *)formDef;

-(NSXMLDocument *)formContents;
-(void)setFormContents:(NSXMLDocument *)formContents;

// Call this before setFormDefinition to not allow editing
-(void)turnOffEditing;

-(id)delegate;
-(void)setDelegate:(id)aDelegate;

-(NSBorderType) borderType;
-(void) setBorderType:(NSBorderType) borderType;

@end

@interface NSObject (CHFormViewDelegate)

-(void)formViewContentsDidChange:(CHFormView *)formView;

@end
