//
//  CHOmnifindWindowController.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on 6/29/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHAppKit/CHAppKit.h>
#import <CHQTKit/CHQTKit.h>
#import <CHQuartz/CHQuartz.h>

@class CHFormView, PGBlockHolderView, PGBlockHolderViewController, PGBlockHolderViewCalendarController;

@interface CHOmnifindWindowController : NSWindowController
{
	IBOutlet NSMatrix *_searchTypeMatrix;
	IBOutlet NSSearchField *_searchField;
	IBOutlet NSProgressIndicator *_searchSpinner;
	IBOutlet NSButton *_advancedDisclosure;
	IBOutlet NSButton *_ignoreCaseCbx;
	IBOutlet NSButton *_ignoreDiacriticsCbx;
	IBOutlet NSButton *_wholeWordsOnlyCbx;
	IBOutlet NSTableView *_queryItemsTable;
	IBOutlet NSTableView *_queryResultsTable;
	IBOutlet NSSplitView *_querySplitView;
	IBOutlet NSButton *_searchContactsCbx;
	IBOutlet NSButton *_searchEventsCbx;
	IBOutlet NSButton *_searchTasksCbx;
	IBOutlet NSButton *_searchNotesCbx;
	
	// Note views:
	IBOutlet NSTextView *_previewTextView;
	IBOutlet NSView *_previewTextSuperview;
	IBOutlet CHPDFBrowserView *_previewPDFBrowserView;
	IBOutlet NSView *_previewPDFBrowserSuperview;
	IBOutlet CHFileBrowserView *_previewFileBrowserView;
	IBOutlet NSView *_previewFileBrowserSuperview;
	IBOutlet CHAudioBrowserView *_previewAudioBrowserView;
	IBOutlet NSView *_previewAudioBrowserSuperview;
	IBOutlet CHImageBrowserView *_previewImageBrowserView;
	IBOutlet NSView *_previewImageBrowserSuperview;
	IBOutlet CHMovieBrowserView *_previewMovieBrowserView;
	IBOutlet NSView *_previewMovieBrowserSuperview;
	IBOutlet CHBookmarkBrowserView *_previewBookmarkBrowserView;
	IBOutlet NSView *_previewBookmarkBrowserSuperview;
	IBOutlet CHWebArchiveBrowserView *_previewWebArchiveBrowserView;
	IBOutlet NSView *_previewWebArchiveBrowserSuperview;
	IBOutlet CHFormView *_previewFormView;
	IBOutlet NSView *_previewFormSuperview;
	// Contact views:
	PGBlockHolderView *_previewContactBlockHolderView;
	IBOutlet NSScrollView *_previewContactBlockHolderScrollView;
	IBOutlet NSView *_previewContactBlockHolderSuperview;
	// Calendar views:
	PGBlockHolderView *_previewCalendarBlockHolderView;
	IBOutlet NSScrollView *_previewCalendarBlockHolderScrollView;
	IBOutlet NSView *_previewCalendarBlockHolderSuperview;
	// Nonretained current view placeholder:
	NSView *_currentPreviewSuperview;
	
	NSTimer *_searchTimer;
	NSMutableArray *_searchResults;
	NSMetadataQuery *_query;
	NSMutableArray *_queryItems;
	BOOL _sortUp;
	PGBlockHolderViewController *_contactBHVController;
	PGBlockHolderViewCalendarController *_calendarBHVController;
}
- (IBAction)advancedClicked:(id)sender;
- (IBAction)searchMatrixClicked:(id)sender;
- (IBAction)searchOptionSelected:(id)sender;

@end
