//
//  CHOpenBaseConnectWindowController.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on 03/28/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString * const CHOBGBookmarkArray;
extern NSString * const CHOBGBookmarkName;

@interface CHOpenBaseConnectWindowController : NSWindowController
{
	IBOutlet NSComboBox *_hostBox;
	IBOutlet NSComboBox *_databaseBox;
	IBOutlet NSTextField *_userNameTxt;
	IBOutlet NSTextField *_passwordTxt;
	IBOutlet NSButton *_connectButton;
	IBOutlet NSPopUpButton *_bookmarksPopup;
	
	NSArray *_hosts;
	NSArray *_databasesOnHost;
	BOOL _hostBoxDidChange;
	
	NSString *_hostName;
	NSString *_databaseName;
	NSString *_userName;
	NSString *_password;
	
	NSString *_readPassword;
	NSDictionary *_lastSelectedBookmark;
}
- (void)setConnectionInfo:(NSDictionary *)connectionInfo;

- (NSString *)hostName;
- (NSString *)databaseName;
- (NSString *)userName;
- (NSString *)password;
- (NSDictionary *)connectionInfoDictForCHDatabase;
- (NSString *)readPassword;
- (void)setReadPassword:(NSString *)readPassword;

- (IBAction)connectClicked:(id)sender;
- (IBAction)cancelClicked:(id)sender;

- (IBAction)addBookmarkAction:(id)sender;
- (IBAction)bookmarkChosenAction:(id)sender;
- (IBAction)removeBookmarkAction:(id)sender;

@end
