//
//  CHSharingDialogController.h
//  StickyBrain3
//
//  Created by Rod Schmidt on 2/21/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CHDatabase;
@class SBUser;
@class SBFolder;
@class ContactSharingController;
@class CalendarSharingController;
@class CHLicenseManager;
@class SBLibrary;

// rob @interface CHSharingDialogController : NSWindowController 
@interface CHSharingDialogController : NSObject	
{
	IBOutlet NSView*					_mainView;		// rob
	IBOutlet NSPopUpButton*				_dbChooser;
	IBOutlet NSPopUpButton*				_typeChooser;	// rob
	IBOutlet NSTableView*				_userTable;
	IBOutlet NSButton*					_addUserButton;
	IBOutlet NSButton*					_deleteUserButton;
	IBOutlet NSOutlineView*				_folderOutline;
	IBOutlet NSPopUpButton*				_markAllButton;
	IBOutlet NSArrayController*			_userTableController;
	IBOutlet NSWindow*					_confirmPasswordSheet;
	IBOutlet NSSecureTextField*			_confirmPasswordField;
	IBOutlet NSButton*					_confirmButton;
	// rob IBOutlet NSTabView*					_tabView;
	IBOutlet NSTableView*				_contactsTable;
	IBOutlet NSTableView*				_calendarTable;		// rob
	IBOutlet ContactSharingController*	_contactController;
	IBOutlet CalendarSharingController*	_calendarController;
	IBOutlet NSButton*					_addCalendarButton;
	IBOutlet NSButton*					_deleteCalendarButton;
	
	NSMutableArray *		_topLevelNibObjects;	// rob
	BOOL					_nibIsLoaded;
	int						_typeIndex;		// rob
	NSMutableArray*			_databases;
	CHDatabase*				_selectedDatabase;
	NSMutableArray*			_users;
	NSMutableDictionary*	_folderPrivileges;
	SBLibrary *				_library;
	NSString*				_passwordToConfirm;
	
	int						_numLicensedNoteUsers;
	int						_numLicensedContactUsers;
	int						_numLicensedCalendarUsers;
	
	CHLicenseManager*		_licenseManager;
}

+(id) instance;

- (id)mainView;

// Set the selected database the dialog will initially display. Call before adminDatabaseSharing
-(void) setSelectedDatabase: (CHDatabase*) db;
-(void)setLicenseManager:(CHLicenseManager*)aLicenseManager;


-(IBAction) databaseChanged: (id) sender;
-(void) loadSelectedDatabase;
-(IBAction) typeChanged: (id) sender;
-(IBAction) markAll: (id) sender;

-(void) insertObject: (SBUser*) user inUsersAtIndex: (int) index;
- (IBAction)deleteUser:(id)sender;
-(void) removeObjectFromUsersAtIndex: (int) index;
-(void) setUsers: (NSMutableArray*) array;
-(BOOL) canRemove;

// Confirm password actions
-(IBAction) endPasswordConfirmSheet: (id) sender;

-(BOOL) anySelectedUserIsAdmin;
-(CHDatabase*) selectedDatabase;
-(NSArray*) selectedUserIDs;

-(void) refreshFolderOutline;

-(void)performNotesLicenseCheck;
-(void)performContactsLicenseCheck;
-(void)performCalendarsLicenseCheck;

@end

@interface SBSharingDialogTableView : NSTableView
{
}

@end

