//
//  OpenBaseLiteHost.h
//  LoginPanel
//
//  Created by Scott Keith on Sun Apr 04 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#define LOGIN_OKAY					0
#define LOGIN_SERVER_DOES_NOT_EXIST 1
#define LOGIN_READ_PASSWORD_FAILURE	2


@interface OpenBaseLiteHost : NSObject {
    NSString *hostName;
    NSString *ipaddress;
    NSString *connectipaddress;
    NSString *ethernetAddress;
    NSString *readHostPassword;
    NSMutableArray *databaseList;
	
	NSString *hostPassword;
	int server_error_code;
}

+ (void)saveREADPasswords;
+ (void)loadREADPasswords;


+ (void)saveConnectionDictionary:(NSDictionary *)connectionDict toFile:(NSString *)filename;
+ (NSDictionary *)loadConnectionDictionaryFromFile:(NSString *)filename;

+ (void)saveHostOptionList:(NSMutableArray *)connectionArray toFile:(NSString *)filename;
+ (NSMutableArray *)loadHostOptionListFromFile:(NSString *)filename;

// Local Host Object
+ (OpenBaseLiteHost *)returnLocalHost;

// Get all the host objects fetched by this application
+ (NSArray *)returnHostPopupOptions;

+ (OpenBaseLiteHost *)hostForIPAddress:(NSString *)ipAddressString;

- (NSString *)hostName;
- (NSString *)ipaddress;

- (void)setHostName:(NSString *)hostNameString;
- (void)setIpaddress:(NSString *)ipaddressString;

- (void)connectAndVerifyHostName;


@end

@interface OpenBaseLiteHost (Databases)
// public methods
- (NSArray *)returnDatabaseNames;
- (NSArray *)returnDatabaseNamesWithFilter:(const char *)match;
- (NSString *)readPassword;
- (NSString *)hostPassword;
- (void)setHostPassword:(NSString *)pwstring;

- (BOOL)checkReadPassword:(NSString *)password;
- (BOOL)checkHostPassword:(NSString *)password;
- (BOOL)doesDatabaseExist:(NSString *)databaseName;
- (BOOL)startDatabase:(NSString *)databaseName usingHostPassword:(NSString *)password;
- (BOOL)createDatabase:(NSString *)databaseName usingHostPassword:(NSString *)password;

- (int)serverErrorCode;
@end

@interface OpenBaseLiteHost (Rendezvous)
+ (void)initRendezvous;
+ (void)stopRendezvous;
+ (int)rendezvousTimestamp;
+ (void)discoveredServicesDidChange:(id)sender;
@end

