//
//  PGAddressBookDAV.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on 4/10/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHDatabaseKit/CHDatabaseKit.h>

// Namespaces for XML HTTP Requests:
extern NSString * const PGABDAVNamespace;
extern NSString * const PGABCalDAVNamespace;
extern NSString * const PGABAppleCalendarServerNamespace;
extern NSString * const PGABiCalNamespace;

// Notifications sent by this class:
extern NSString * const PGAddressBookDAVWillClearCalendarCacheNotification;
extern NSString * const PGAddressBookDAVWillDisconnectNotification;
extern NSString * const PGAddressBookDAVWillReloadNotification;
extern NSString * const PGAddressBookDAVDidReloadNotification;

@interface PGAddressBookDAV : PGAddressBook
{
	NSString *_abName;
	NSString *_abID;
	NSURL *_calDAVInfoURL;
	NSString *_username;
	NSString *_password;
	NSURL *_calDAVCalendarHomeURL;
	NSArray *_cachedCalendars;
	NSRecursiveLock *_cachedCalendarsLock;
	NSMutableDictionary *_cachedAccessLevelsKeyedByCalendarID;
	NSTimer *_calendarsRefreshTimer;
	BOOL _isDisconnecting;
	
	NSMutableSet *_calendarRecordsToAdd;
	NSLock *_calendarRecordsToAddLock;
	NSMutableSet *_calendarRecordsToUpdate;
	NSLock *_calendarRecordsToUpdateLock;
	NSMutableSet *_calendarRecordsToDelete;
	NSLock *_calendarRecordsToDeleteLock;
	NSConditionLock *_saveLock;
}
- (id)initWithName:(NSString *)name infoURL:(NSURL *)url user:(NSString *)username password:(NSString *)password;

- (void)beginBackgroundCalendarReload;
//- (void)clearCalendarCache;
- (void)setTimeToRefreshCalendarsInMinutes:(unsigned int)minutes;

@end
