//
//  PGBlockContentViewAddressEntity.h
//  Organizer
//
//  Created by Nick Zitzmann on Wed May 12 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHAppKit/CHAppKit.h>
#import "PGBlockContentViewController.h"

@class PGMultiValue, PGAutocompleteTextField, PGRaisedTextView;

extern NSString * const PGBCVAddressEntityDidChangeMultiValueNotification;	// posted when a major change is made to the address multi-value

@interface PGBlockContentViewAddressEntity : PGBlockContentViewController <PGBlockContentViewDifferentiator>
{
	IBOutlet CHTransparentPopUpButton *_addressLabelMenu;
	IBOutlet PGRaisedTextView *_streetValueView;
	IBOutlet NSTextField *_cityLabelView;
	IBOutlet PGAutocompleteTextField *_cityValueView;
	IBOutlet NSTextField *_regionLabelView;
	IBOutlet PGAutocompleteTextField *_regionValueView;
	IBOutlet NSTextField *_postalCodeLabelView;
	IBOutlet PGAutocompleteTextField *_postalCodeValueView;
	IBOutlet NSTextField *_countryLabelView;
	IBOutlet PGAutocompleteTextField *_countryValueView;
	IBOutlet CHTransparentPopUpButton *_actionButton;
	NSMenu *_addressFormatMenu;
	
	PGMultiValue *_multiValue;
	unsigned int _currentIndex;
	
	NSString *_initEditString;
	BOOL _textWasEdited;
	NSAttributedString *_initTextViewEditString;
	
	float _originalContentHeight;
	NSPoint _originalStreetValueScrollViewOrigin;
	BOOL _needsExpansionChange;
	
	NSView *_labelOrder[3];
	NSView *_valueOrder[3];
}
- (void)setIndexToDisplay:(int)newCurrentIndex;

- (IBAction)labelChanged:(id)sender;
- (IBAction)addMultiValue:(id)sender;
- (IBAction)removeClicked:(id)sender;
- (IBAction)copyMailingLabel:(id)sender;
- (IBAction)openAddressMap:(id)sender;

- (id)addressLabelMenu;
- (NSDictionary *)currentAddressFormat;

@end


@interface PGAddressBlockContentView : NSView
{
	IBOutlet NSButton *_addButton;
	IBOutlet NSButton *_removeButton;
	
	NSTrackingRectTag _trackingRectTag;
}

@end
