//
//  PGBlockContentViewController.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on Tue Apr 06 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CHAppKit/CHAppKit.h>

extern NSString * const PGBlockViewRecordWasUpdatedNotification;
extern NSString * const PGBlockViewSummaryImageNeedsUpdateNotification;
extern NSString * const PGBlockViewSummaryPropertyNeedsUpdateNotification;

@class PGPerson, PGBlockView, PGAddressBook;

// Tag constants
#define PGViewTitle				1
#define PGViewFirstName			2
#define PGViewMiddleName		3
#define PGViewLastName			4
#define PGViewSuffix			5
#define PGViewOrganization		6
#define PGViewJobTitle			7
#define PGViewDepartment		8
//#define PGViewIsCompany		9
#define PGViewNickname			10
#define PGViewImage				11
#define PGViewFullName			12
#define PGViewFirstNamePhonetic	13
#define PGViewLastNamePhonetic	14
#define PGViewMaidenName		15

@protocol PGBlockContentViewDifferentiator <NSObject>
- (void)setAddedProperties:(NSArray *)addedProperties overwrittenProperties:(NSArray *)overwrittenProperties;
@end

@interface PGBlockContentViewController : CHNibLoadingObject
{
	@private
	PGPerson *_origPerson;
	@protected
	IBOutlet NSView *_content;
	IBOutlet NSView *_initialKeyView;
	IBOutlet NSView *_finalKeyView;
	id _record;
	PGBlockView *_nonretainedBlockView;
	PGAddressBook *_lastAddressBook;
	
	NSMutableIndexSet *_addedIndexes;
	NSMutableIndexSet *_overwrittenIndexes;
}
+ (id)controller;
- (BOOL)loadNib;	// can be overridden by superclasses; don't call directly
- (NSView *)contentView;
- (void)setRecord:(id)record;
- (void)setAddressBook:(PGAddressBook *)ab;
- (void)updateRecord;
- (void)updateSummaryViewProperty:(NSString *)property updateImage:(BOOL)updateImage;
- (void)setBlockView:(PGBlockView *)blockView;

- (NSView *)initialKeyView;
- (NSView *)finalKeyView;

- (IBAction)editClickedAreaInTableView:(id)sender;

@end
