//
//  PGBlockView.h
//  CHOpenBaseGUI
//
//  Created by Jerry Halls on Wed Dec 17 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>

#define PGSpanAllColumns		10000

@class PGAutohighlightingButton, PGBlockContentViewController, PGBlockHolderView, PGTheme;

@interface PGBlockView : NSView {
	unsigned int		_blockID;
	NSColor				*_color;
	NSString			*_titleString;
	NSImage				*_icon;
	NSDictionary		*_attributesDictionary;
	float				_titleHeight;
	NSView				*_contentView;
	float				_contentViewHeight;
	PGBlockContentViewController *_contentViewController;
	id					_titleView;
	unsigned int		_numberOfColumnsSpanned;
	NSColor				*_textColor;
	PGTheme				*_theme;
	BOOL				_isExpanded;
	PGAutohighlightingButton *_addButton;
	BOOL				_canCollapse;
	PGBlockHolderView	*_nonretainedBlockHolderView;
	
	NSArray *_controlsThatAreEditable;
	NSArray *_controlsThatAreEnabled;
}

- (void)viewDidMoveToSuperview;
- (void)initTitleAttributes;

- (void)setBlockID:(unsigned int)blockID;
- (unsigned int)blockID;
- (void)setTitle:(NSString*)aTitleString;
- (NSString*)title;
- (void)setTitleView:(id)aTitleView;
- (id)titleView;
- (PGTheme *)theme;
- (void)setTheme:(PGTheme *)aTheme;
- (void)setIcon:(NSImage*)aIcon;

- (void)setColor:(NSColor*)aColor;
- (NSColor *)textColor;
- (void)setTextColor:(NSColor *)aColor;
- (void)setContentViewController:(PGBlockContentViewController *)newContentViewController;
- (void)setCanCollapse:(BOOL)newCan;

- (float)viewHeight;
- (float)contentAreaHeight;
- (NSRect)frameRectForContentView;
- (PGBlockContentViewController *)contentViewController;
- (PGBlockHolderView *)blockHolderView;

- (unsigned int)numberOfColumnsSpanned;
- (void)setNumberOfColumnsSpanned:(unsigned int)newNumber;

- (BOOL)isExpanded;
- (void)setExpanded:(BOOL)expanded;
- (void)setEditable:(BOOL)flag;
- (void)setEnabled:(BOOL)flag;

- (void)updateBlockSize;

@end
