//
//  PGPeoplePickerView.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on 07/26/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CHAppKit/CHAppKit.h>
#import <CHDatabaseKit/CHDatabaseKit.h>

#if MAC_OS_X_VERSION_10_4 <= MAC_OS_X_VERSION_MAX_ALLOWED
extern NSString * const PGPeoplePickerGroupSelectionDidChangeNotification;
extern NSString * const PGPeoplePickerNameSelectionDidChangeNotification;

@interface PGPeoplePickerView : NSView
{
	IBOutlet NSView *_contentView;
	IBOutlet NSTableView *_peopleTable;
	IBOutlet CHGradientOutlineView *_groupsTable;
	IBOutlet NSTextField *_numberOfCardsTxt;
	IBOutlet NSSearchField *_searchField;
	
	CHDatabase *_db;
	NSMutableArray *_filteredPeople;
	NSTimer *_searchTimer;
	NSMutableArray *_selectedPeople;
	NSMutableArray *_groupProxyPool;
}
- (CHDatabase *)database;
- (void)setDatabase:(CHDatabase *)database;
- (BOOL)allowsMultipleSelection;
- (void)setAllowsMultipleSelection:(BOOL)allow;
- (id)target;
- (void)setTarget:(id)target;
- (SEL)groupDoubleAction;
- (void)setGroupDoubleAction:(SEL)action;
- (SEL)nameDoubleAction;
- (void)setNameDoubleAction:(SEL)action;
- (NSArray *)selectedGroups;
- (NSArray *)selectedRecords;
- (void)selectGroup:(PGGroup *)group byExtendingSelection:(BOOL)extendSelection;
- (void)selectRecord:(PGRecord *)record byExtendingSelection:(BOOL)extendSelection;
- (void)selectRecords:(NSArray *)records byExtendingSelection:(BOOL)extendSelection;
- (void)addProperty:(NSString *)property;

- (IBAction)search:(id)sender;
- (IBAction)exportVCard:(id)sender;
- (IBAction)openInSOHOContacts:(id)sender;
@end
#endif
