//
//  PGTheme.h
//  CHOpenBaseGUI
//
//  Created by Nick Zitzmann on 7/19/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface PGTheme : NSObject
{
	NSMutableDictionary *_themeDict;
}
+ (NSString *)pathToThemesFolder;

- (id)initWithThemeName:(NSString *)themeName;

- (NSColor*)backgroundColor;
- (NSColor*)fieldFontColor;
- (NSColor*)summaryFontColor;
- (NSColor *)titleFontColor;

- (NSImage*)personPlaceholderImage;
- (NSImage*)organizationPlaceholderImage;
- (NSImage*)personPlaceholderSummaryImage;
- (NSImage*)organizationPlaceholderSummaryImage;

- (NSDictionary *)contentArea;
- (NSDictionary *)titleBar;

- (NSImage *)bottomCenterImageForBlockName:(NSString *)blockName loadTallImages:(BOOL)loadTallImages;
- (NSImage *)bottomLeftImageForBlockName:(NSString *)blockName loadTallImages:(BOOL)loadTallImages;
- (NSImage *)bottomRightImageForBlockName:(NSString *)blockName loadTallImages:(BOOL)loadTallImages;
- (NSImage *)collapsedCenterImageForBlockName:(NSString *)blockName;
- (NSImage *)collapsedLeftImageForBlockName:(NSString *)blockName;
- (NSImage *)collapsedRightImageForBlockName:(NSString *)blockName;
- (NSImage *)middleCenterImageForBlockName:(NSString *)blockName;
- (NSImage *)middleLeftImageForBlockName:(NSString *)blockName loadTallImages:(BOOL)loadTallImages;
- (NSImage *)middleRightImageForBlockName:(NSString *)blockName loadTallImages:(BOOL)loadTallImages;
- (NSImage *)summaryBottomCenterImage;
- (NSImage *)summaryBottomLeftImage;
- (NSImage *)summaryBottomRightImage;
- (NSImage *)summaryMiddleCenterImage;
- (NSImage *)summaryMiddleLeftImage;
- (NSImage *)summaryMiddleRightImage;
- (NSImage *)summaryTopCenterImage;
- (NSImage *)summaryTopLeftImage;
- (NSImage *)summaryTopRightImage;
- (NSImage *)tallMiddleCenterImage;
- (NSImage *)topCenterImageForBlockName:(NSString *)blockName;
- (NSImage *)topLeftImageForBlockName:(NSString *)blockName;
- (NSImage *)topRightImageForBlockName:(NSString *)blockName;

@end
