//
//  SBPrivatePasswordDialogController.h
//  CHOpenBaseGUI
//
//  Created by Rod Schmidt on Wed Jun 09 2004.
//  Copyright (c) 2004 Chronos, LC. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <CHAppKit/CHAppKit.h>

@class SBLibrary;

@interface SBPrivatePasswordDialogController : CHNibLoadingObject 
{
	IBOutlet NSWindow *		_changeDialog;
	IBOutlet NSTextField *	_oldPasswordField;
	IBOutlet NSTextField *	_newPasswordField;
	IBOutlet NSTextField *	_verifyPasswordField;
	IBOutlet NSTextField *	_passwordHintField;
	IBOutlet NSButton *		_changeOKButton;
	IBOutlet NSButton *		_changeCancelButton;
	
	IBOutlet NSWindow *		_passwordDialog;
	IBOutlet NSTextField *	_passwordField;
	IBOutlet NSButton *		_passwordOKButton;
	IBOutlet NSButton *		_passwordCancelButton;
	
	id			_nonretainedDelegate;
	BOOL		_runningPasswordDialogAsSheet;
	NSData *	_encryptedContents;
	NSWindow *	_lastDisplayedDialog;
}

+(SBPrivatePasswordDialogController*) instance;

-(id)delegate;
-(void)setDelegate:(id)delegate;
-(void)setEncryptedContents:(NSData *)contents;
-(BOOL)runChangePasswordDialog;
-(BOOL)runPasswordDialog;	// warning; this may cause freezes
-(void)runPasswordSheetInWindow:(NSWindow *)aWindow modalDelegate:(id)aDelegate didEndSelector:(SEL)didEndSelector;

-(NSString *)password;
-(IBAction)endDialog:(id)sender;

@end


@interface NSObject (SBPrivatePasswordDialogControllerDelegate)
- (void)tellWindowsPrivateNotePasswordChanged;
- (void)setPrivateNotesPassword:(NSString *)password;
@end
