//
//  CHPDFBrowserView.h
//  CHAppKit
//
//  Created by Rod Schmidt on 5/23/2005.
//  Copyright 2005 Chronos, LC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>
#import <CHAppKit/CHAppKit.h>

@class CHControlBar;

@interface CHPDFBrowserView : CHBrowserView 
{
	IBOutlet NSSearchField*			_searchField;
	IBOutlet NSSegmentedControl*	_outlineTypeChooser;
	IBOutlet NSOutlineView*			_tocView;
	IBOutlet PDFView*				_pdfView;
	IBOutlet NSTabView*				_tabView;
	IBOutlet NSTextField*			_searchCountLabel;
	IBOutlet NSTableView*			_searchResultsTable;
	IBOutlet NSProgressIndicator*	_searchProgressSpinner;
	IBOutlet NSButton*				_addButton;
	IBOutlet NSPopUpButton*			_actionButton;
	IBOutlet NSButton*				_pageUpButton;
	IBOutlet NSButton*				_pageDownButton;
	IBOutlet NSPopUpButton*			_zoomPopup;
	IBOutlet NSTextField*			_pageField;
	IBOutlet NSTextField*			_totalPagesLabel;
	IBOutlet NSDrawer*				_drawer;
	
	PDFOutline*		_pdfOutline;
	NSMutableArray*	_searchResults;
	BOOL			_displayingDragHerePDF;
	BOOL			_displayingMissingPDF;
	BOOL			_dontTellDelegate;
	BOOL			_hasDrawer;
	NSData*			_pdfData;
	BOOL			_pdfDataSet;
	NSString*		_filename;
	BOOL			_canSetDocument;
	BOOL			_linked;
}

-(IBAction) openWith: (id) sender;
-(IBAction) revealInFinder: (id) sender;
-(IBAction) saveCopyAs: (id) sender;

//-(IBAction) changeOutlineType: (id) sender;
-(IBAction) continuous: (id) sender;
-(IBAction) searchPDFDocument: (id) sender;
-(IBAction) singlePage: (id) sender;
-(IBAction) facingPages: (id) sender;
-(IBAction) setDocument: (id) sender;
//-(IBAction) takeDestinationFromOutline: (id) sender;
-(IBAction) zoom: (id) sender;
-(IBAction) goToPage: (id) sender;
-(IBAction)goToPreviousPage:(id)sender;
-(IBAction)goToNextPage:(id)sender;

-(BOOL) hasDrawer;
-(void) setHasDrawer: (BOOL) flag;

-(NSString*) filename;
-(void) setFilename: (NSString*) filename data: (NSData*) pdfData;
-(void)importImage:(NSImage *)anImage withTitle:(NSString *)title;
-(void)importImageAsNewPage:(NSImage *)anImage;

-(NSData*) PDFData;

// Return the plain text of the PDF
-(NSString*) PDFText;

-(CGFloat) scale;
-(void) setScale: (CGFloat) scale;

-(NSUInteger) page;
-(void) setPage: (NSUInteger) pageNumber;

-(PDFDisplayMode) displayMode;
-(void) setDisplayMode: (PDFDisplayMode) mode;

-(BOOL) canSetDocument;
-(void) setCanSetDocument: (BOOL) flag;

-(BOOL) isLinked;
-(void) setLinked: (BOOL) linked;

-(void) searchPDFDocumentFor:(NSString *) searchText;
-(void) cancelSearch;

@end

@interface CHPDFBrowserView (Delegate)
-(void) pdfBrowserDocumentChanged: (CHPDFBrowserView*) pdfBrowser;
-(void) pdfBrowserSettingsChanged: (CHPDFBrowserView*) pdfBrowser;
@end
